'compile with -e, -ex or -exx

#Include Once "md/helper/mdTryCatch.bi"
#Include Once "md/lang/mdException.bi"

Try(OuterCatch)
	Dim As Integer fileIsOpen = FALSE
	Print "Open file:"
	Open "TryCatch.pp.bas" For Input As #1
	Print "File is open!"
	fileIsOpen = TRUE
	
	Print "Throw exception:"
	Throw(New mdException("My Exception"))
	Print "This line will never be reached!"
	
	Catch(OuterCatch)
		Print NEWLINE & "Outer catch:"
		Print TraceException(OuterCatch_ERROR) & NEWLINE
	EndCatch
	
	Finally(OuterCatch)
		Print "Finally:"
		Try(InnerCatch)
			If fileIsOpen Then
				Print "Close file:"
				Close #1
				Print "File is closed!"
			Else
				Print "Nothing to do here!"
			EndIf
			
			Catch(InnerCatch)
				Print NEWLINE & "Inner catch:"
				Print TraceException(InnerCatch_ERROR) & NEWLINE
			EndCatch
		EndTry
	EndFinally
EndTry

Sleep


'##############
'Output if file does not exist:
'---------------------
'Open file:
'
'Outer catch:
'Exception in xxx.bas at (9)
'File not found signal
'
'Finally:
'Nothing to do here!
'---------------------
'
'Output if file exist:
'---------------------
'Open file:
'File is open!
'Throw exception:
'
'Outer catch:
'Exception in FbTemp.bas at (14):
'My Exception
'
'Finally:
'Close file:
'File is closed!
'---------------------
'##############