'mdCollectionHelper - by MOD

'no Java representation


#Ifndef NEWLINE
	#If Defined(__FB_WIN32__)
		#Define NEWLINE !"\r\n"
	#ElseIf Defined(__FB_LINUX__)
		#Define NEWLINE !"\n"
	#EndIf
#EndIf


#Include Once "md/util/mdList.bi"
#Include Once "md/util/mdMap.bi"
#Include Once "md/lang/mdString.bi"

#Ifndef __MDCOLLECTIONSHELPER_BI__
#Define __MDCOLLECTIONSHELPER_BI__

mdListDeclare(String)
mdMapDeclare(String, String)

Type mdCollectionsHelper Extends mdObject
	Declare Static Function createList(ByRef l As String) As mdList(String)
	Declare Static Function createMap(ByRef m As String) As mdMap(String, String)
	Declare Static Function encode(ByRef s As String) As String
	Declare Static Function decode(ByRef s As String) As String
End Type

MODULE_SCOPE Function mdCollectionsHelper.createList(ByRef l As String) As mdList(String)
	Dim As mdList(String) list
	
	Dim As Integer openListCount
	Dim As Integer openMapCount
	
	Dim As String value, temp
	Dim As Integer foundValue
	
	If Len(l) Then
		For i As Integer = 0 To Len(l) - 1
			Select Case l[i]
				Case 44 ',
					If openListCount = 1 AndAlso openMapCount = 0 Then
						value = temp
						temp = ""
						foundValue = TRUE
						i += 1 'skip following space
					Else
						temp += Chr(l[i])
					EndIf
				Case 91 '[
					openListCount += 1
					If openListCount > 1 Then
						temp += Chr(l[i])
					EndIf
				Case 93 ']
					openListCount -= 1
					If openListCount > 0 Then
						temp += Chr(l[i])
					ElseIf openListCount = 0 Then
						value = temp
						foundValue = TRUE
					EndIf
				Case 123 '{
					openMapCount += 1
					temp += Chr(l[i])
				Case 125 '}
					openMapCount -= 1
					temp += Chr(l[i])
				Case Else
					temp += Chr(l[i])
			End Select
			
			If foundValue AndAlso openListCount <= 1 Then
				list.add(value)
				foundValue = FALSE
			EndIf
		Next
	EndIf
	
	Return list
End Function

MODULE_SCOPE Function mdCollectionsHelper.createMap(ByRef m As String) As mdMap(String, String)
	Dim As mdMap(String, String) map
	
	Dim As Integer openListCount
	Dim As Integer openMapCount
	
	Dim As String key, value, temp, tempRet
	Dim As Integer foundKey, foundValue
	
	If Len(m) Then
		For i As Integer = 0 To Len(m) - 1
			Select Case m[i]
				Case 44 ',
					If openMapCount = 1 AndAlso openListCount = 0 Then
						value = temp
						temp = ""
						foundValue = TRUE
						i += 1 'skip following space
					Else
						temp += Chr(m[i])
					EndIf
				Case 61 '=
					If openMapCount = 1 AndAlso openListCount = 0 Then
						key = temp
						temp = ""
						foundKey = TRUE
					Else
						temp += Chr(m[i])
					EndIf
				Case 91 '[
					openListCount += 1
					temp += Chr(m[i])
				Case 93 ']
					openListCount -= 1
					temp += Chr(m[i])
				Case 123 '{
					openMapCount += 1
					If openMapCount > 1 Then
						temp += Chr(m[i])
					EndIf
				Case 125 '}
					openMapCount -= 1
					If openMapCount > 0 Then
						temp += Chr(m[i])
					ElseIf openMapCount = 0 Then
						value = temp
						foundValue = TRUE
					EndIf
				Case Else
					temp += Chr(m[i])
			End Select
			
			If foundKey AndAlso foundValue AndAlso openMapCount <= 1 Then
				tempRet = map.put(key, value)
				foundKey = FALSE
				foundValue = FALSE
			EndIf
		Next
	EndIf
	
	Return map
End Function

MODULE_SCOPE Function mdCollectionsHelper.encode(ByRef s As String) As String
	Dim As mdString ret = s
	Dim As String array()
	ret.split(array(), "[")
	If @array(0) <> NULL Then
		ret = ""
		For i As Integer = LBound(array) To UBound(array)
			Dim As mdString temp = array(i)
			temp = temp.replace("]", "[BRACKETCLOSE]")
			ret += temp + IIf(i < UBound(array), "[BRACKETOPEN]", "")
		Next
	EndIf
	ret = ret.replace(!"\r\n", "[NEWLINE]")
	ret = ret.replace(!"\n", "[NEWLINE]")
	ret = ret.replace(!"\r", "[NEWLINE]")
	ret = ret.replace("=", "[EQUALS]")
	ret = ret.replace(",", "[COMMA]")
	ret = ret.replace("{", "[BRACEOPEN]")
	ret = ret.replace("}", "[BRACECLOSE]")
	Return ret
End Function

MODULE_SCOPE Function mdCollectionsHelper.decode(ByRef s As String) As String
	Dim As mdString ret = s
	ret = ret.replace("[NEWLINE]", NEWLINE)
	ret = ret.replace("[EQUALS]", "=")
	ret = ret.replace("[COMMA]", ",")
	ret = ret.replace("[BRACEOPEN]", "{")
	ret = ret.replace("[BRACECLOSE]", "}")
	ret = ret.replace("[BRACKETOPEN]", "[")
	ret = ret.replace("[BRACKETCLOSE]", "]")
	Return ret
End Function

#EndIf '__MDCOLLECTIONSHELPER_BI__
