'mdPersistenceHelper - by MOD

'no Java representation


#Include Once "md/util/mdSet.bi"
#Include Once "md/util/mdMap.bi"

mdSetDeclare(String)
mdMapDeclare(String, mdSetString)
mdMapDeclare(String, mdMapStringmdSetString)

#Ifndef __MDPERSISTENCEHELPER_BI__
#Define __MDPERSISTENCEHELPER_BI__

#Define COLUMN_IS_PRIMARY_KEY "primary key"
#Define COLUMN_NULL "null"
#Define COLUMN_NOT_NULL "not null"
#Define COLUMN_IS_UNIQUE "unique"

#Define COLUMN_DATATYPE_LENGTH "length " 'use as 'COLUMN_DATATYPE_LENGTH & 255'
#Define COLUMN_DATATYPE_UNSIGNED "unsigned"
#Define COLUMN_DATATYPE_ZEROFILL "zerofill"
#Define COLUMN_DATATYPE_TEXT_TYPE_BINARY "binary"
#Define COLUMN_DATATYPE_TEXT_TYPE_ASCII "ascii"
#Define COLUMN_DATATYPE_TEXT_TYPE_UNICODE "unicode"

#Define COLUMN_DATATYPE_TINYINT "tinyint"
#Define COLUMN_DATATYPE_SMALLINT "smallint"
#Define COLUMN_DATATYPE_MEDIUMINT "mediumint"
#Define COLUMN_DATATYPE_INT "int"
#Define COLUMN_DATATYPE_INTEGER "integer"
#Define COLUMN_DATATYPE_BIGINT "bigint"
#Define COLUMN_DATATYPE_REAL "real"
#Define COLUMN_DATATYPE_DOUBLE "double"
#Define COLUMN_DATATYPE_FLOAT "float"
#Define COLUMN_DATATYPE_SINGLE "float"
#Define COLUMN_DATATYPE_DECIMAL "decimal"
#Define COLUMN_DATATYPE_NUMERIC "numeric"
#Define COLUMN_DATATYPE_DATE "date"
#Define COLUMN_DATATYPE_TIME "time"
#Define COLUMN_DATATYPE_TIMESTAMP "timestamp"
#Define COLUMN_DATATYPE_DATETIME "datetime"
#Define COLUMN_DATATYPE_YEAR "year"
#Define COLUMN_DATATYPE_CHAR "char"
#Define COLUMN_DATATYPE_VARCHAR "varchar"
#Define COLUMN_DATATYPE_BINARY "binary"
#Define COLUMN_DATATYPE_VARBINARY "varbinary"
#Define COLUMN_DATATYPE_TINYBLOB "tinyblob"
#Define COLUMN_DATATYPE_BLOB "blob"
#Define COLUMN_DATATYPE_MEDIUMBLOB "mediumblob"
#Define COLUMN_DATATYPE_LONGBLOB "longblob"
#Define COLUMN_DATATYPE_TINYTEXT "tinytext"
#Define COLUMN_DATATYPE_TEXT "text"
#Define COLUMN_DATATYPE_MEDIUMTEXT "mediumtext"
#Define COLUMN_DATATYPE_LONGTEXT "longtext"

Type mdPersistenceHelper Extends mdObject
	Public:
	Declare Constructor ()
	
	Declare Virtual Sub setColumn(ByRef table As String, ByRef column As String)
	Declare Virtual Sub setColumn(ByRef table As String, ByRef column As String, ByRef columnProperty As String)
	Declare Virtual Sub setColumn(ByRef table As String, ByRef column As String, ByRef columnProperties As mdSet(String))
	Declare Virtual Sub setColumns(ByRef table As String, ByRef columns As mdSet(String))
	
	Declare Virtual Function getTables() As mdMap(String, mdMapStringmdSetString)
	
	Declare Virtual Function toString() As String
	Declare Virtual Operator Cast() As String
	
	Private:
	As mdMap(String, mdMapStringmdSetString) tables 'Map:(TableName, Map:(ColumnName, Set:(PropertyStrings)))
End Type

MODULE_SCOPE Constructor mdPersistenceHelper()
	
End Constructor

MODULE_SCOPE Sub mdPersistenceHelper.setColumn(ByRef table As String, ByRef column As String)
	If This.tables.containsKey(table) Then
		Dim As mdMap(String, mdSetString) tempMap
		tempMap = This.tables.get(table)
		If tempMap.containsKey(column) = FALSE Then
			Dim As mdSet(String) tempSet
			tempSet = tempMap.put(column, tempSet)
			tempMap = This.tables.put(table, tempMap)
		EndIf
	Else
		Dim As mdSet(String) tempSet
		Dim As mdMap(String, mdSetString) tempMap
		tempSet = tempMap.put(column, tempSet)
		tempMap = This.tables.put(table, tempMap)
	EndIf
End Sub

MODULE_SCOPE Sub mdPersistenceHelper.setColumn(ByRef table As String, ByRef column As String, ByRef columnProperty As String)
	If This.tables.containsKey(table) Then
		Dim As mdMap(String, mdSetString) tempMap
		tempMap = This.tables.get(table)
		Dim As mdSet(String) tempSet
		If tempMap.containsKey(column) = FALSE Then
			tempSet.add(columnProperty)
			tempSet = tempMap.put(column, tempSet)
			tempMap = This.tables.put(table, tempMap)
		Else
			tempSet = tempMap.get(column)
			tempSet.add(columnProperty)
			tempSet = tempMap.put(column, tempSet)
			tempMap = This.tables.put(table, tempMap)
		EndIf
	Else
		Dim As mdSet(String) tempSet
		tempSet.add(columnProperty)
		Dim As mdMap(String, mdSetString) tempMap
		tempSet = tempMap.put(column, tempSet)
		tempMap = This.tables.put(table, tempMap)
	EndIf
End Sub

MODULE_SCOPE Sub mdPersistenceHelper.setColumn(ByRef table As String, ByRef column As String, ByRef columnProperties As mdSet(String))
	If This.tables.containsKey(table) Then
		Dim As mdMap(String, mdSetString) tempMap
		tempMap = This.tables.get(table)
		Dim As mdSet(String) tempSet
		If tempMap.containsKey(column) = FALSE Then
			tempSet = tempMap.put(column, columnProperties)
			tempMap = This.tables.put(table, tempMap)
		Else
			tempSet = tempMap.get(column)
			tempSet.addAll(columnProperties)
			tempSet = tempMap.put(column, tempSet)
			tempMap = This.tables.put(table, tempMap)
		EndIf
	Else
		Dim As mdSet(String) tempSet
		Dim As mdMap(String, mdSetString) tempMap
		tempSet = tempMap.put(column, columnProperties)
		tempMap = This.tables.put(table, tempMap)
	EndIf
End Sub

MODULE_SCOPE Sub mdPersistenceHelper.setColumns(ByRef table As String, ByRef columns As mdSet(String))
	If This.tables.containsKey(table) Then
		Dim As mdMap(String, mdSetString) tempMap
		tempMap = This.tables.get(table)
		
		Dim As String column
		ForEach(String, column In columns)
			If tempMap.containsKey(column) = FALSE Then
				Dim As mdSet(String) tempSet
				tempSet = tempMap.put(column, tempSet)
				tempMap = This.tables.put(table, tempMap)
			EndIf
		NextEach
	Else
		Dim As mdSet(String) tempSet
		Dim As mdMap(String, mdSetString) tempMap
		Dim As String column
		ForEach(String, column In columns)
			tempSet = tempMap.put(column, tempSet)
		NextEach
		tempMap = This.tables.put(table, tempMap)
		tempMap = This.tables.put(table, tempMap)
	EndIf
End Sub

MODULE_SCOPE Function mdPersistenceHelper.getTables() As mdMap(String, mdMapStringmdSetString)
	Return This.tables
End Function

MODULE_SCOPE Function mdPersistenceHelper.toString() As String
	Return This.tables
End Function

MODULE_SCOPE Operator mdPersistenceHelper.Cast() As String
	Return This.tables
End Operator

MODULE_SCOPE Operator = (ByRef lhs As mdPersistenceHelper, ByRef rhs As mdPersistenceHelper) As Boolean
	Return Str(lhs) = Str(rhs)
End Operator

#EndIf '__MDPERSISTENCEHELPER_BI__
