'mdException - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/lang/Exception.html


#Include Once "md/lang/mdThrowable.bi"


#Ifndef __MDEXCEPTION_BI__
#Define __MDEXCEPTION_BI__

Type mdException Extends mdThrowable
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef message As String)
	Declare Constructor (ByRef message As String, ByRef cause As mdThrowable)
	Declare Constructor (ByRef cause As mdThrowable)
	Declare Virtual Destructor ()
	
	Declare Virtual Function toString() As String
	
	Declare Virtual Operator Cast() As String
	
	Protected:
	As mdThrowable Ptr cause
End Type

MODULE_SCOPE Constructor mdException()
	'This = This.fillInStackTrace()
	This.cause = @This
End Constructor

MODULE_SCOPE Constructor mdException(ByRef message As String)
	'This = This.fillInStackTrace()
	This.detailMessage = message
	This.cause = @This
End Constructor

MODULE_SCOPE Constructor mdException(ByRef message As String, ByRef cause As mdThrowable)
	'This = This.fillInStackTrace()
	This.detailMessage = message
	This.cause = @cause
End Constructor

MODULE_SCOPE Constructor mdException(ByRef cause As mdThrowable)
	'This = This.fillInStackTrace()
	This.detailMessage = cause.toString()
	This.cause = @cause
End Constructor

MODULE_SCOPE Destructor mdException()
	
End Destructor

MODULE_SCOPE Function mdException.toString() As String
	Dim As String ret
	Dim As String message = This.getLocalizedMessage()
	If message <> "" Then
		ret = "mdException: " & message
	EndIf
	Return ret
End Function

MODULE_SCOPE Operator mdException.Cast() As String
	Return This.toString()
End Operator

MODULE_SCOPE Operator = (ByRef lhs As mdException, ByRef rhs As mdException) As Integer
	Return Str(lhs) = Str(rhs)
End Operator

#EndIf '__MDEXCEPTION_BI__
