'mdStackTraceElement - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/lang/StackTraceElement.html


#Include Once "md/lang/mdObject.bi"


#Ifndef __MDSTACKTRACEELEMENT_BI__
#Define __MDSTACKTRACEELEMENT_BI__

Type mdStackTraceElement Extends mdObject
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef declaringClass As String, ByRef methodName As String, ByRef fileName As String, ByVal lineNumber As Integer)
	
	'Declare Virtual Function equals(ByRef obj As mdObject) As Boolean
	Declare Virtual Function equals(ByRef obj As mdStackTraceElement) As Boolean
	Declare Virtual Function getClassName() As String
	Declare Virtual Function getFileName() As String
	Declare Virtual Function getLineNumber() As Integer
	Declare Virtual Function getMethodName() As String
	Declare Virtual Function hashCode() As Integer
	Declare Virtual Function isNativeMethod() As Boolean
	Declare Virtual Function toString() As String
	
	Declare Virtual Operator Cast() As String
	
	Protected:
	As String declaringClass
	As String methodName
	As String fileName
	As Integer lineNumber
End Type

MODULE_SCOPE Constructor mdStackTraceElement()
	
End Constructor

MODULE_SCOPE Constructor mdStackTraceElement(ByRef declaringClass As String, ByRef methodName As String, ByRef fileName As String, ByVal lineNumber As Integer)
	This.declaringClass = declaringClass
	This.methodName = methodName
	This.fileName = fileName
	This.lineNumber = lineNumber
End Constructor

'MODULE_SCOPE Function mdStackTraceElement.equals(ByRef obj As mdObject) As Boolean

MODULE_SCOPE Function mdStackTraceElement.equals(ByRef obj As mdStackTraceElement) As Boolean
	Return obj.toString() = This.toString()
End Function

MODULE_SCOPE Function mdStackTraceElement.getClassName() As String
	Return This.declaringClass
End Function

MODULE_SCOPE Function mdStackTraceElement.getFileName() As String
	Return This.fileName
End Function

MODULE_SCOPE Function mdStackTraceElement.getLineNumber() As Integer
	Return This.lineNumber
End Function

MODULE_SCOPE Function mdStackTraceElement.getMethodName() As String
	Return This.methodName
End Function

MODULE_SCOPE Function mdStackTraceElement.hashCode() As Integer
	Return Cast(Integer, @This)
End Function

MODULE_SCOPE Function mdStackTraceElement.isNativeMethod() As Boolean
	Return TRUE
End Function

MODULE_SCOPE Function mdStackTraceElement.toString() As String
	Dim As String ret
	
	ret &= This.getClassName() & "." & This.methodName
	ret &= "("
	If This.fileName <> "" Then
		ret &= This.fileName
	Else
		ret &= "Unknown Source"
	EndIf
	If This.lineNumber <> 0 Then
		ret &= ":" & This.lineNumber
	EndIf
	ret &= ")"
	Return ret
End Function

MODULE_SCOPE Operator mdStackTraceElement.Cast() As String
	Return This.toString()
End Operator

MODULE_SCOPE Operator = (ByRef lhs As mdStackTraceElement, ByRef rhs As mdStackTraceElement) As Integer
	Return Str(lhs) = Str(rhs)
End Operator

#EndIf '__MDSTACKTRACEELEMENT_BI__
