'mdFileHandler - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/logging/FileHandler.html


#Include Once "md/util/logging/mdHandler.bi"


#Ifndef __MDFILEHANDLER_BI__
#Define __MDFILEHANDLER_BI__

Type mdFileHandler Extends mdHandler
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef pattern As String)
	Declare Constructor (ByRef pattern As String, ByVal append_ As Boolean)
	Declare Constructor (ByRef pattern As String, ByVal limit As Integer, ByVal count As Integer)
	Declare Constructor (ByRef pattern As String, ByVal limit As Integer, ByVal count As Integer, ByVal append_ As Boolean)
	Declare Virtual Destructor ()
	
	Declare Virtual /'Abstract'/ Sub close()
	Declare Virtual /'Abstract'/ Sub flush()
	Declare Virtual /'Abstract'/ Sub publish(ByRef record As mdLogRecord)
	
	Declare Virtual Operator Cast() As String
	
	Protected:
	As String file
	As Boolean append_
	As Integer limit
	As Integer count
	
	Private:
	As Integer fileHandlerId
	As Integer isFresh
End Type

MODULE_SCOPE Constructor mdFileHandler()
	This.Constructor("mdFileHandler.log", 0, 0, TRUE)
End Constructor

MODULE_SCOPE Constructor mdFileHandler(ByRef pattern As String)
	This.Constructor(pattern, 0, 0, TRUE)
End Constructor

MODULE_SCOPE Constructor mdFileHandler(ByRef pattern As String, ByVal append_ As Boolean)
	This.Constructor(pattern, 0, 0, append_)
End Constructor

MODULE_SCOPE Constructor mdFileHandler(ByRef pattern As String, ByVal limit As Integer, ByVal count As Integer)
	This.Constructor(pattern, limit, count, TRUE)
End Constructor

MODULE_SCOPE Constructor mdFileHandler(ByRef pattern As String, ByVal limit As Integer, ByVal count As Integer, ByVal append_ As Boolean)
	This.file = pattern
	This.limit = limit
	This.count = count
	This.append_ = append_
	
	Dim As Integer openRetValue
	This.fileHandlerId = FreeFile
	If This.fileHandlerId = 0 Then
		Dim As mdException ex = "File handle error"
		This.reportError("Open error", ex, mdErrorManager.OPEN_FAILURE)
	EndIf
	If This.append_ Then
		openRetValue = Open(This.file For Append As #fileHandlerId)
	Else
		openRetValue = Open(This.file For Output As #fileHandlerId)
	EndIf
	If openRetValue <> 0 Then
		Dim As mdException ex = "Open error"
		This.reportError("Open error", ex, mdErrorManager.OPEN_FAILURE)
	Else
		isFresh = TRUE
	EndIf
End Constructor

MODULE_SCOPE Destructor mdFileHandler()
	This.flush()
	This.close()
End Destructor

MODULE_SCOPE Sub mdFileHandler.close()
	Static As Integer isClosed = FALSE
	If isClosed = FALSE Then
		If FALSE Then
			Dim As mdException ex = "Close error"
			This.reportError("Close error", ex, mdErrorManager.CLOSE_FAILURE)
		Else
			Print #fileHandlerId, Trim(This.formatter.getTail(@This), NEWLINE)
			If FALSE Then
				Dim As mdException ex = "Write error"
				This.reportError("Write error", ex, mdErrorManager.WRITE_FAILURE)
			EndIf
		EndIf
		.Close #fileHandlerId
		isClosed = TRUE
	EndIf
End Sub

MODULE_SCOPE Sub mdFileHandler.flush()
	If FALSE Then
		Dim As mdException ex = "Flush error"
		This.reportError("Flush error", ex, mdErrorManager.FLUSH_FAILURE)
	EndIf
End Sub

MODULE_SCOPE Sub mdFileHandler.publish(ByRef record As mdLogRecord)
	If record.getLevel().intValue() >= This.getLevel().intValue() Then
		If This.isLoggable(record) Then
			Dim As String ret
			ret &= This.formatter.format(record)
			If FALSE Then
				Dim As mdException ex = "Format error"
				This.reportError("Format error", ex, mdErrorManager.FORMAT_FAILURE)
			EndIf
			
			If isFresh Then
				Print #fileHandlerId, Trim(This.formatter.getHead(@This), NEWLINE)
				If FALSE Then
					Dim As mdException ex = "Write error"
					This.reportError("Write error", ex, mdErrorManager.WRITE_FAILURE)
				EndIf
				isFresh = FALSE
			EndIf
			
			Print #fileHandlerId, Trim(ret, NEWLINE)
			If FALSE Then
				Dim As mdException ex = "Write error"
				This.reportError("Write error", ex, mdErrorManager.WRITE_FAILURE)
			EndIf
		EndIf
	EndIf
End Sub

MODULE_SCOPE Operator mdFileHandler.Cast() As String
	Return ""
End Operator

MODULE_SCOPE Operator = (ByRef lhs As mdFileHandler, ByRef rhs As mdFileHandler) As Integer
	Return @lhs = @rhs
End Operator

#EndIf '__MDFILEHANDLER_BI__
