'mdFormatter - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/logging/Formatter.html - http://docs.oracle.com/javase/6/docs/api/java/util/logging/SimpleFormatter.html


#Include Once "md/lang/mdObject.bi"
#Include Once "md/util/logging/mdHandler.bi"
#Include Once "md/util/logging/mdLogRecord.bi"
#Include Once "md/lang/mdString.bi"
#Include Once "string.bi"


#Ifndef __MDFORMATTER_BI__
#Define __MDFORMATTER_BI__

#Ifndef mdHandler
	Type mdHandlerAlias As mdHandler
#Else
	#Define mdHandlerAlias mdHandler
#EndIf

Type mdFormatter Extends mdObject
	Public:
	Declare Virtual /'Abstract'/ Function format(ByRef record As mdLogRecord) As String
	Declare Virtual Function formatMessage(ByRef record As mdLogRecord) As String
	Declare Virtual Function getHead(ByVal h As mdHandlerAlias Ptr) As String
	Declare Virtual Function getTail(ByVal h As mdHandlerAlias Ptr) As String
	
	'Protected:
	Declare Constructor ()
End Type

MODULE_SCOPE Constructor mdFormatter()
	
End Constructor

MODULE_SCOPE Function mdFormatter.format(ByRef record As mdLogRecord) As String
	Dim As String ret
	Dim As Double millis = record.getMillisDouble()
	ret = ..Format(millis, "mm-dd-yyyy hh:mm:ss ")
	If record.getSourceClassName() <> "" Then
		ret &= record.getSourceClassName()
	Else
		ret &= record.getLoggerName()
	EndIf
	If record.getSourceMethodName() <> "" Then
		ret &= " " & record.getSourceMethodName()
	EndIf
	ret &= NEWLINE
	ret &= record.getLevel().getLocalizedName()
	ret &= ": "
	ret &= This.getHead(NULL)
	ret &= This.formatMessage(record)
	ret &= This.getTail(NULL)
	If Trim(record.getThrown().getStackTrace(), NEWLINE) <> "" Then
		ret &= NEWLINE
		ret &= record.getThrown().getStackTrace()
	EndIf
	
	Return ret
End Function

MODULE_SCOPE Function mdFormatter.formatMessage(ByRef record As mdLogRecord) As String
	Dim As mdString tempString = record.getMessage()
	Dim As mdResourceBundle catalog = record.getResourceBundle()
	tempString = catalog.getString(tempString)
	
	Dim As String params()
	record.getParameters(params())
	If @params(0) <> NULL Then
		For i As Integer = LBound(params) To UBound(params)
			tempString = tempString.replace("{" & i & "}", params(i))
		Next
	EndIf
	Return tempString
End Function

MODULE_SCOPE Function mdFormatter.getHead(ByVal h As mdHandlerAlias Ptr) As String
	Return ""
End Function

MODULE_SCOPE Function mdFormatter.getTail(ByVal h As mdHandlerAlias Ptr) As String
	Return ""
End Function

#EndIf '__MDFORMATTER_BI__
