'mdHandler - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/logging/Handler.html


#Include Once "md/lang/mdObject.bi"
#Include Once "md/util/logging/mdErrorManager.bi"
#Include Once "md/lang/mdException.bi"
#Include Once "md/util/logging/mdFilter.bi"
#Include Once "md/util/logging/mdFormatter.bi"
#Include Once "md/util/logging/mdLevel.bi"
#Include Once "md/util/logging/mdLogRecord.bi"


#Ifndef __MDHANDLER_BI__
#Define __MDHANDLER_BI__

Type mdHandler Extends mdObject
	Public:
	Declare Virtual Destructor ()
	
	Declare Virtual /'Abstract'/ Sub close()
	Declare Virtual /'Abstract'/ Sub flush()
	Declare Virtual Function getEncoding() As String
	Declare Virtual Function getErrorManager() As mdErrorManager
	Declare Virtual Function getFilter() As mdFilter
	Declare Virtual Function getFormatter() As mdFormatter
	Declare Virtual Function getLevel() As mdLevel
	Declare Virtual Function isLoggable(ByRef record As mdLogRecord) As Boolean
	Declare Virtual /'Abstract'/ Sub publish(ByRef record As mdLogRecord)
	Declare Virtual Sub setEncoding(ByRef enc As String)
	Declare Virtual Sub setErrorManager(ByRef em As mdErrorManager)
	Declare Virtual Sub setFilter(ByRef newFilter As mdFilter)
	Declare Virtual Sub setFormatter(ByRef newFormatter As mdFormatter)
	Declare Virtual Sub setLevel(ByRef newLevel As mdLevel)
	
	Declare Virtual Function equals(ByRef handler As mdHandler) As Boolean
	Declare Virtual Function toString() As String
	
	Declare Virtual Operator Cast() As String
	
	'Protected:
	Declare Constructor ()
	Protected:
	Declare Virtual Sub reportError(ByRef msg As String, ByRef ex As mdException, ByVal code As Integer)
	
	As String enc
	As mdErrorManager em
	As mdFilter filter
	As mdFormatter formatter
	As mdLevel level
End Type

MODULE_SCOPE Constructor mdHandler()
	
End Constructor

MODULE_SCOPE Destructor mdHandler()
	This.flush()
	This.close()
End Destructor

MODULE_SCOPE Sub mdHandler.close()
	If FALSE Then
		Dim As mdException ex = "Close error"
		This.reportError("Close error", ex, mdErrorManager.CLOSE_FAILURE)
	EndIf
End Sub

MODULE_SCOPE Sub mdHandler.flush()
	If FALSE Then
		Dim As mdException ex = "Flush error"
		This.reportError("Flush error", ex, mdErrorManager.FLUSH_FAILURE)
	EndIf
End Sub

MODULE_SCOPE Function mdHandler.getEncoding() As String
	Return This.enc
End Function

MODULE_SCOPE Function mdHandler.getErrorManager() As mdErrorManager
	Return This.em
End Function

MODULE_SCOPE Function mdHandler.getFilter() As mdFilter
	Return This.filter
End Function

MODULE_SCOPE Function mdHandler.getFormatter() As mdFormatter
	Return This.formatter
End Function

MODULE_SCOPE Function mdHandler.getLevel() As mdLevel
	Return This.level
End Function

MODULE_SCOPE Function mdHandler.isLoggable(ByRef record As mdLogRecord) As Boolean
	Return TRUE
End Function

MODULE_SCOPE Sub mdHandler.publish(ByRef record As mdLogRecord)
	If record.getLevel().intValue() >= This.getLevel().intValue() Then
		If This.isLoggable(record) Then
			Dim As String ret
			ret &= This.formatter.getHead(@This)
			ret &= This.formatter.format(record)
			If FALSE Then
				Dim As mdException ex = "Format error"
				This.reportError("Format error", ex, mdErrorManager.FORMAT_FAILURE)
			EndIf
			ret &= This.formatter.getTail(@This)
			If FALSE Then
				Dim As mdException ex = "Open error"
				This.reportError("Open error", ex, mdErrorManager.OPEN_FAILURE)
			EndIf
			Print ret
			If FALSE Then
				Dim As mdException ex = "Write error"
				This.reportError("Write error", ex, mdErrorManager.WRITE_FAILURE)
			EndIf
		EndIf
	EndIf
End Sub

MODULE_SCOPE Sub mdHandler.reportError(ByRef msg As String, ByRef ex As mdException, ByVal code As Integer)
	This.em.error(msg, ex, code)
End Sub

MODULE_SCOPE Sub mdHandler.setEncoding(ByRef enc As String)
	This.enc = enc
End Sub

MODULE_SCOPE Sub mdHandler.setErrorManager(ByRef em As mdErrorManager)
	This.em = em
End Sub

MODULE_SCOPE Sub mdHandler.setFilter(ByRef newFilter As mdFilter)
	This.filter = newFilter
End Sub

MODULE_SCOPE Sub mdHandler.setFormatter(ByRef newFormatter As mdFormatter)
	This.formatter = newFormatter
End Sub

MODULE_SCOPE Sub mdHandler.setLevel(ByRef newLevel As mdLevel)
	This.level = newLevel
End Sub

MODULE_SCOPE Function mdHandler.equals(ByRef handler As mdHandler) As Boolean
	Return This.toString() = handler.toString()
End Function

MODULE_SCOPE Function mdHandler.toString() As String
	Return ""
End Function

MODULE_SCOPE Operator mdHandler.Cast() As String
	Return This.toString()
End Operator

MODULE_SCOPE Operator = (ByRef lhs As mdHandler, ByRef rhs As mdHandler) As Integer
	Return lhs.equals(rhs)
End Operator

#EndIf '__MDHANDLER_BI__
