'mdLogRecord - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/logging/LogRecord.html


#Include Once "md/lang/mdObject.bi"
#Include Once "md/util/logging/mdLevel.bi"
#Include Once "md/util/mdResourceBundle.bi"
#Include Once "md/lang/mdThrowable.bi"
#Include Once "md/util/mdList.bi"

mdListDeclare(String)

#Include Once "datetime.bi"


#Ifndef __MDLOGRECORD_BI__
#Define __MDLOGRECORD_BI__

Type mdLogRecord Extends mdObject
	Public:
	Declare Constructor (ByRef level As mdLevel, ByRef msg As String)
	
	Declare Virtual Function getLevel() As mdLevel
	Declare Virtual Function getLoggerName() As String
	Declare Virtual Function getMessage() As String
	Declare Virtual Function getMillis() As Long
	Declare Virtual Function getMillisDouble() As Double
	Declare Virtual Function getParameters(parameters() As String) As Boolean
	Declare Virtual Function getResourceBundle() As mdResourceBundle
	Declare Virtual Function getResourceBundleName() As String
	Declare Virtual Function getSequenceNumber() As Long
	Declare Virtual Function getSourceClassName() As String
	Declare Virtual Function getSourceMethodName() As String
	Declare Virtual Function getThreadID() As Integer
	Declare Virtual Function getThrown() As mdThrowable
	Declare Virtual Sub setLevel(ByRef level As mdLevel)
	Declare Virtual Sub setLoggerName(ByRef name_ As String)
	Declare Virtual Sub setMessage(ByRef message As String)
	Declare Virtual Sub setMillis(ByVal millis As Long)
	Declare Virtual Sub setMillisDouble(ByVal millis As Double)
	Declare Virtual Sub setParameters(parameters() As String)
	Declare Virtual Sub setResourceBundle(ByRef resourceBundle As mdResourceBundle)
	Declare Virtual Sub setResourceBundleName(ByRef name_ As String)
	Declare Virtual Sub setSequenceNumber(ByVal seq As Long)
	Declare Virtual Sub setSourceClassName(ByRef sourceClassName As String)
	Declare Virtual Sub setSourceMethodName(ByRef sourceMethodName As String)
	Declare Virtual Sub setThreadID(ByVal threadID As Integer)
	Declare Virtual Sub setThrown(ByRef thrown As mdThrowable)
	
	Protected:
	As mdLevel level
	As String msg
	As String loggerName
	As Long millis
	As Double millisDouble
	As mdList(String) parameterList
	As mdResourceBundle resourceBundle
	As String resourceBundleName
	As Long seq
	As Integer threadID
	As mdThrowable thrown
	As String sourceClassName
	As String sourceMethodName
	
	Static As Long globalSequenceNumber
End Type

Dim As Long mdLogRecord.globalSequenceNumber = 0

MODULE_SCOPE Constructor mdLogRecord(ByRef level As mdLevel, ByRef msg As String)
	This.level = level
	This.msg = msg
	This.millis = Timer 'for Linux this will work fine
	This.millisDouble = Now 'FreeBASICs Now should do the job
	globalSequenceNumber += 1
	This.seq = globalSequenceNumber
End Constructor

MODULE_SCOPE Function mdLogRecord.getLevel() As mdLevel
	Return This.level
End Function

MODULE_SCOPE Function mdLogRecord.getLoggerName() As String
	Return This.loggerName
End Function

MODULE_SCOPE Function mdLogRecord.getMessage() As String
	Return This.msg
End Function

MODULE_SCOPE Function mdLogRecord.getMillis() As Long
	Return This.millis
End Function

MODULE_SCOPE Function mdLogRecord.getMillisDouble() As Double
	Return This.millisDouble
End Function

MODULE_SCOPE Function mdLogRecord.getParameters(parameters() As String) As Boolean
	Return parameterList.toArray(parameters())
End Function

MODULE_SCOPE Function mdLogRecord.getResourceBundle() As mdResourceBundle
	Return This.resourceBundle
End Function

MODULE_SCOPE Function mdLogRecord.getResourceBundleName() As String
	Return This.resourceBundleName
End Function

MODULE_SCOPE Function mdLogRecord.getSequenceNumber() As Long
	Return This.seq
End Function

MODULE_SCOPE Function mdLogRecord.getSourceClassName() As String
	Return This.sourceClassName
End Function

MODULE_SCOPE Function mdLogRecord.getSourceMethodName() As String
	Return This.sourceMethodName
End Function

MODULE_SCOPE Function mdLogRecord.getThreadID() As Integer
	Return This.threadID
End Function

MODULE_SCOPE Function mdLogRecord.getThrown() As mdThrowable
	Return This.thrown
End Function

MODULE_SCOPE Sub mdLogRecord.setLevel(ByRef level As mdLevel)
	This.level = level
End Sub

MODULE_SCOPE Sub mdLogRecord.setLoggerName(ByRef name_ As String)
	This.loggerName = name_
End Sub

MODULE_SCOPE Sub mdLogRecord.setMessage(ByRef message As String)
	This.msg = message
End Sub

MODULE_SCOPE Sub mdLogRecord.setMillis(ByVal millis As Long)
	This.millis = millis
End Sub

MODULE_SCOPE Sub mdLogRecord.setMillisDouble(ByVal millis As Double)
	This.millisDouble = millis
End Sub

MODULE_SCOPE Sub mdLogRecord.setParameters(parameters() As String)
	parameterList.clear()
	For i As Integer = LBound(parameters) To UBound(parameters)
		parameterList.add(parameters(i))
	Next
End Sub

MODULE_SCOPE Sub mdLogRecord.setResourceBundle(ByRef resourceBundle As mdResourceBundle)
	This.resourceBundle = resourceBundle
End Sub

MODULE_SCOPE Sub mdLogRecord.setResourceBundleName(ByRef name_ As String)
	This.resourceBundleName = name_
End Sub

MODULE_SCOPE Sub mdLogRecord.setSequenceNumber(ByVal seq As Long)
	This.seq = seq
End Sub

MODULE_SCOPE Sub mdLogRecord.setSourceClassName(ByRef sourceClassName As String)
	This.sourceClassName = sourceClassName
End Sub

MODULE_SCOPE Sub mdLogRecord.setSourceMethodName(ByRef sourceMethodName As String)
	This.sourceMethodName = sourceMethodName
End Sub

MODULE_SCOPE Sub mdLogRecord.setThreadID(ByVal threadID As Integer)
	This.threadID = threadID
End Sub

MODULE_SCOPE Sub mdLogRecord.setThrown(ByRef thrown As mdThrowable)
	This.thrown = thrown
End Sub

#EndIf '__MDLOGRECORD_BI__
