'mdLogger - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/logging/Logger.html


#Ifndef NEWLINE
	#If Defined(__FB_WIN32__)
		#Define NEWLINE !"\r\n"
	#ElseIf Defined(__FB_LINUX__)
		#Define NEWLINE !"\n"
	#EndIf
#EndIf


#Include Once "md/lang/mdObject.bi"
#Include Once "md/lang/mdInteger.bi"
#Include Once "md/util/logging/mdHandler.bi"
#Include Once "md/util/logging/mdFilter.bi"
#Include Once "md/util/logging/mdLevel.bi"
#Include Once "md/lang/mdThrowable.bi"
#Include Once "md/util/mdMap.bi"
#Include Once "md/util/mdList.bi"

mdMapDeclare(String, mdInteger)
mdListDeclare(mdHandler, Ptr)


#Ifndef __MDLOGGER_BI__
#Define __MDLOGGER_BI__

Type mdLoggerParent As mdLogger

Type mdLogger Extends mdObject
	Public:
	Declare Constructor ()
	Declare Virtual Destructor ()
	
	Declare Virtual Sub addHandler(ByRef handler As mdHandler)
	Declare Virtual Sub config(ByRef msg As String)
	'Declare Virtual Sub entering(ByRef sourceClass As String, ByRef sourceMethod As String)
	'Declare Virtual Sub entering(ByRef sourceClass As String, ByRef sourceMethod As String, ByRef param1 As String)
	'Declare Virtual Sub entering(ByRef sourceClass As String, ByRef sourceMethod As String, params() As String)
	'Declare Virtual Sub exiting(ByRef sourceClass As String, ByRef sourceMethod As String)
	'Declare Virtual Sub exiting(ByRef sourceClass As String, ByRef sourceMethod As String, ByRef result As String)
	Declare Virtual Sub fine(ByRef msg As String)
	Declare Virtual Sub finer(ByRef msg As String)
	Declare Virtual Sub finest(ByRef msg As String)
	Declare Static Function getAnonymousLogger() As mdLogger
	Declare Static Function getAnonymousLogger(ByRef resourceBundleName As String) As mdLogger
	Declare Virtual Function getFilter() As mdFilter
	Declare Virtual Function getHandlers(handlers() As mdHandler) As Boolean
	Declare Virtual Function getLevel() As mdLevel
	Declare Static Function getLogger(ByRef className As String) As mdLogger
	Declare Static Function getLogger(ByRef className As String, ByRef resourceBundleName As String) As mdLogger
	Declare Virtual Function getName() As String
	Declare Virtual Function getParent() As mdLogger
	Declare Virtual Function getResourceBundle() As mdResourceBundle
	Declare Virtual Function getResourceBundleName() As String
	Declare Virtual Function getUseParentHandlers() As Boolean
	Declare Virtual Sub info(ByRef msg As String)
	Declare Virtual Function isLoggable(ByRef level As mdLevel) As Boolean
	Declare Virtual Sub log(ByRef level As mdLevel, ByRef msg As String)
	Declare Virtual Sub log(ByRef level As mdLevel, ByRef msg As String, ByRef param1 As String)
	Declare Virtual Sub log(ByRef level As mdLevel, ByRef msg As String, params() As String)
	Declare Virtual Sub log(ByRef level As mdLevel, ByRef msg As String, ByRef thrown As mdThrowable)
	Declare Virtual Sub log(ByRef record As mdLogRecord)
	Declare Virtual Sub logp(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef msg As String)
	Declare Virtual Sub logp(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef msg As String, ByRef param1 As String)
	Declare Virtual Sub logp(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef msg As String, params() As String)
	Declare Virtual Sub logp(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef msg As String, ByRef thrown As mdThrowable)
	Declare Virtual Sub logrb(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef bundleName As String, ByRef msg As String)
	Declare Virtual Sub logrb(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef bundleName As String, ByRef msg As String, ByRef param1 As String)
	Declare Virtual Sub logrb(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef bundleName As String, ByRef msg As String, params() As String)
	Declare Virtual Sub logrb(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef bundleName As String, ByRef msg As String, ByRef thrown As mdThrowable)
	Declare Virtual Sub removeHandler(ByRef handler As mdHandler)
	Declare Virtual Sub setFilter(ByRef newFilter As mdFilter)
	Declare Virtual Sub setLevel(ByRef level As mdLevel)
	Declare Virtual Sub setParent(ByRef parent As mdLogger)
	Declare Virtual Sub setUseParentHandlers(ByVal useParentHandlers As Boolean)
	Declare Virtual Sub severe(ByRef msg As String)
	Declare Virtual Sub throwing(ByRef sourceClass As String, ByRef sourceMethod As String, ByRef thrown As mdThrowable)
	Declare Virtual Sub warning(ByRef msg As String)
	
	Static As Const ZString*7 GLOBAL_LOGGER_NAME
	
	Declare Constructor (ByRef _n As mdLogger) 'supposed to be Protected
	Protected:
	Declare Constructor (ByRef className As String)
	Declare Constructor (ByRef className As String, ByRef resourceBundleName As String)
	
	As mdMap(String, mdInteger) loggerMap 'className to value
	As mdList(mdHandler, Ptr) handlers
	As mdFilter filter
	As mdLevel level
	As Integer levelValue
	As mdResourceBundle resourceBundle
	As String resourceBundleName
	As mdLoggerParent Ptr parent
	As Boolean useParentHandlers = TRUE
	As String className
	
	Static As mdLogger instance
End Type

Dim As Const ZString*7 mdLogger.GLOBAL_LOGGER_NAME = "global"
Dim As mdLogger mdLogger.instance = Type<mdLogger>()

MODULE_SCOPE Constructor mdLogger()
	This.level = mdLevel.SEVERE
End Constructor

MODULE_SCOPE Constructor mdLogger(ByRef _n As mdLogger)
	
End Constructor

MODULE_SCOPE Constructor mdLogger(ByRef className As String)
	This.className = className
	This.levelValue = mdLevel.INFO.intValue()
End Constructor

MODULE_SCOPE Constructor mdLogger(ByRef className As String, ByRef resourceBundleName As String)
	If resourceBundleName <> "" Then
		
	EndIf
	This.className = className
	This.levelValue = mdLevel.INFO.intValue()
End Constructor

MODULE_SCOPE Destructor mdLogger()
	
End Destructor

MODULE_SCOPE Sub mdLogger.addHandler(ByRef handler As mdHandler)
	This.handlers.add(@handler)
End Sub

MODULE_SCOPE Sub mdLogger.config(ByRef msg As String)
	This.log(mdLevel.CONFIG, msg)
End Sub

'MODULE_SCOPE Sub mdLogger.entering(ByRef sourceClass As String, ByRef sourceMethod As String)
'	
'End Sub
'
'MODULE_SCOPE Sub mdLogger.entering(ByRef sourceClass As String, ByRef sourceMethod As String, ByRef param1 As String)
'	
'End Sub
'
'MODULE_SCOPE Sub mdLogger.entering(ByRef sourceClass As String, ByRef sourceMethod As String, params() As String)
'	
'End Sub
'
'MODULE_SCOPE Sub mdLogger.exiting(ByRef sourceClass As String, ByRef sourceMethod As String)
'	
'End Sub
'
'MODULE_SCOPE Sub mdLogger.exiting(ByRef sourceClass As String, ByRef sourceMethod As String, ByRef result As String)
'	
'End Sub

MODULE_SCOPE Sub mdLogger.fine(ByRef msg As String)
	This.log(mdLevel.FINE, msg)
End Sub

MODULE_SCOPE Sub mdLogger.finer(ByRef msg As String)
	This.log(mdLevel.FINER, msg)
End Sub

MODULE_SCOPE Sub mdLogger.finest(ByRef msg As String)
	This.log(mdLevel.FINEST, msg)
End Sub

MODULE_SCOPE Function mdLogger.getAnonymousLogger() As mdLogger
	Dim As mdLogger annonInstance
	Return annonInstance
End Function

MODULE_SCOPE Function mdLogger.getAnonymousLogger(ByRef resourceBundleName As String) As mdLogger
	Dim As mdLogger annonInstance
	annonInstance.resourceBundleName = resourceBundleName
	Return annonInstance
End Function

MODULE_SCOPE Function mdLogger.getFilter() As mdFilter
	Return This.filter
End Function

MODULE_SCOPE Function mdLogger.getHandlers(handlers() As mdHandler) As Boolean
	Dim As mdHandler Ptr tempHandlers()
	This.handlers.toArray(tempHandlers())
	ReDim handlers(UBound(tempHandlers))
	For i As Integer = 0 To UBound(tempHandlers)
		handlers(i) = *tempHandlers(i)
	Next
	Return FALSE
End Function

MODULE_SCOPE Function mdLogger.getLevel() As mdLevel
	Return This.level
End Function

MODULE_SCOPE Function mdLogger.getLogger(ByRef className As String) As mdLogger
	'Static As mdLogger instance
	'Return instance
	mdLogger.instance.className = className
	Return mdLogger.instance
End Function

MODULE_SCOPE Function mdLogger.getLogger(ByRef className As String, ByRef resourceBundleName As String) As mdLogger
	mdLogger.instance.className = className
	mdLogger.instance.resourceBundleName = resourceBundleName
	Return mdLogger.instance
End Function

MODULE_SCOPE Function mdLogger.getName() As String
	Return This.className
End Function

MODULE_SCOPE Function mdLogger.getParent() As mdLogger
	Return *Cast(mdLogger Ptr, This.parent)
End Function

MODULE_SCOPE Function mdLogger.getResourceBundle() As mdResourceBundle
	Return This.resourceBundle
End Function

MODULE_SCOPE Function mdLogger.getResourceBundleName() As String
	Return This.resourceBundleName
End Function

MODULE_SCOPE Function mdLogger.getUseParentHandlers() As Boolean
	Return This.useParentHandlers
End Function

MODULE_SCOPE Sub mdLogger.info(ByRef msg As String)
	This.log(mdLevel.INFO, msg)
End Sub

MODULE_SCOPE Function mdLogger.isLoggable(ByRef level As mdLevel) As Boolean
	Return (level.intValue() >= This.getLevel().intValue()) AndAlso (level.intValue() <> mdLevel.OFF.intValue())
End Function

MODULE_SCOPE Sub mdLogger.log(ByRef level As mdLevel, ByRef msg As String)
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.log(ByRef level As mdLevel, ByRef msg As String, ByRef param1 As String)
	Dim As String params(0)
	params(0) = param1
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	record.setParameters(params())
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.log(ByRef level As mdLevel, ByRef msg As String, params() As String)
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	record.setParameters(params())
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.log(ByRef level As mdLevel, ByRef msg As String, ByRef thrown As mdThrowable)
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	record.setThrown(thrown)
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.log(ByRef record As mdLogRecord)
	record.setLoggerName(This.getName())
	Dim As mdLevel level = record.getLevel()
	If This.isLoggable(level) Then
		If This.filter.isLoggable(record) Then
			Dim As mdLogger Ptr logger = @This
			While logger <> NULL
				If logger->handlers.size() > 0 Then
					For i As Integer = 0 To logger->handlers.size() - 1
						Dim As mdHandler Ptr tempHandler = logger->handlers.get(i)
						tempHandler->publish(record)
					Next
				EndIf
				If logger->getUseParentHandlers() = FALSE Then
					Exit While
				EndIf
				logger = logger->parent
			Wend
'			If This.handlers.size() > 0 Then
'				For i As Integer = 0 To This.handlers.size() - 1
'					Dim As mdHandler Ptr tempHandler = This.handlers.get(i)
'					tempHandler->publish(record)
'				Next
'			Else
'				Dim As mdHandler defaultHandler
'				defaultHandler.publish(record)
'			EndIf
		EndIf
	EndIf
End Sub

MODULE_SCOPE Sub mdLogger.logp(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef msg As String)
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	record.setSourceClassName(sourceClass)
	record.setSourceMethodName(sourceMethod)
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.logp(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef msg As String, ByRef param1 As String)
	Dim As String params(0)
	params(0) = param1
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	record.setParameters(params())
	record.setSourceClassName(sourceClass)
	record.setSourceMethodName(sourceMethod)
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.logp(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef msg As String, params() As String)
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	record.setParameters(params())
	record.setSourceClassName(sourceClass)
	record.setSourceMethodName(sourceMethod)
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.logp(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef msg As String, ByRef thrown As mdThrowable)
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	record.setThrown(thrown)
	record.setSourceClassName(sourceClass)
	record.setSourceMethodName(sourceMethod)
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.logrb(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef bundleName As String, ByRef msg As String)
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	record.setSourceClassName(sourceClass)
	record.setSourceMethodName(sourceMethod)
	record.setResourceBundleName(bundleName)
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.logrb(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef bundleName As String, ByRef msg As String, ByRef param1 As String)
	Dim As String params(0)
	params(0) = param1
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	record.setParameters(params())
	record.setSourceClassName(sourceClass)
	record.setSourceMethodName(sourceMethod)
	record.setResourceBundleName(bundleName)
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.logrb(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef bundleName As String, ByRef msg As String, params() As String)
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	record.setParameters(params())
	record.setSourceClassName(sourceClass)
	record.setSourceMethodName(sourceMethod)
	record.setResourceBundleName(bundleName)
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.logrb(ByRef level As mdLevel, ByRef sourceClass As String, ByRef sourceMethod As String, ByRef bundleName As String, ByRef msg As String, ByRef thrown As mdThrowable)
	Dim As mdLogRecord record = mdLogRecord(level, msg)
	record.setThrown(thrown)
	record.setSourceClassName(sourceClass)
	record.setSourceMethodName(sourceMethod)
	record.setResourceBundleName(bundleName)
	This.log(record)
End Sub

MODULE_SCOPE Sub mdLogger.removeHandler(ByRef handler As mdHandler)
	For i As Integer = 0 To This.handlers.size() - 1
		Dim As mdHandler tempHandler = *This.handlers.get(i)
		If tempHandler.equals(handler) Then
			This.handlers.remove(i)
		EndIf
	Next
End Sub

MODULE_SCOPE Sub mdLogger.setFilter(ByRef newFilter As mdFilter)
	This.filter = newFilter
End Sub

MODULE_SCOPE Sub mdLogger.setLevel(ByRef level As mdLevel)
	This.level = level
End Sub

MODULE_SCOPE Sub mdLogger.setParent(ByRef parent As mdLogger)
	This.parent = @parent
End Sub

MODULE_SCOPE Sub mdLogger.setUseParentHandlers(ByVal useParentHandlers As Boolean)
	This.useParentHandlers = useParentHandlers
End Sub

MODULE_SCOPE Sub mdLogger.severe(ByRef msg As String)
	This.log(mdLevel.SEVERE, msg)
End Sub

MODULE_SCOPE Sub mdLogger.throwing(ByRef sourceClass As String, ByRef sourceMethod As String, ByRef thrown As mdThrowable)
	This.logp(mdLevel.FINER, sourceClass, sourceMethod, "THROW", thrown)
End Sub

MODULE_SCOPE Sub mdLogger.warning(ByRef msg As String)
	This.log(mdLevel.WARNING, msg)
End Sub

#EndIf '__MDLOGGER_BI__
