'mdArrayIterator - by MOD

'https://commons.apache.org/proper/commons-collections/javadocs/api-2.1.1/org/apache/commons/collections/iterators/ArrayIterator.html


#Include Once "md/util/mdList.bi"

#Undef ForEachPtr
#Macro ForEachPtr(T, var_, object_, P)
	Scope
	Dim As mdArrayIterator##T##P var_##mdArrayIterator##T##P = object_
	While var_##mdArrayIterator##T##P.hasNext()
		var_ = var_##mdArrayIterator##T##P.nex()
#EndMacro

#Define mdArrayIteratorPtr(E, P) mdArrayIterator##E##P
#Define mdArrayIterator(E, P...) mdArrayIteratorPtr(E, P)

#Macro mdArrayIteratorDeclarePtr(E, P)

#Ifndef mdArrayIterator##E##P
'#Define __MDARRAYITERATOR_BI__

mdListDeclarePtr(E, P)

Type mdArrayIterator##E##P Extends mdIterator##E##P
	Public:
	Declare Constructor (ByVal node As mdBasicNode##E##P Ptr)
	Declare Constructor (ByRef c As mdCollection##E##P)
	Declare Constructor (array() As E P)
	Declare Constructor (array() As E P, ByVal start As Integer)
	Declare Constructor (array() As E P, ByVal start As Integer, ByVal end_ As Integer)
	
	Declare Virtual Sub getArray(array() As E P)
	Declare Virtual Function getClass() As String
	Declare Virtual Sub setArray(array() As E P)
	
	Private:
	innerList As mdList(E, P)
End Type

MODULE_SCOPE Constructor mdArrayIterator##E##P(ByVal node As mdBasicNode##E##P Ptr)
	This.cur = node
End Constructor

MODULE_SCOPE Constructor mdArrayIterator##E##P(ByRef c As mdCollection##E##P)
	This.cur = c.iterator().cur
End Constructor

MODULE_SCOPE Constructor mdArrayIterator##E##P(array() As E P)
	This.setArray(array())
End Constructor

MODULE_SCOPE Constructor mdArrayIterator##E##P(array() As E P, ByVal start As Integer)
	If @array(0) <> NULL AndAlso UBound(array) >= start Then
		Dim As E P tempArray(0 To UBound(array) - start)
		For i As Integer = 0 To UBound(array) - start
			tempArray(i) = array(i + start)
		Next
		This.setArray(tempArray())
	EndIf
End Constructor

MODULE_SCOPE Constructor mdArrayIterator##E##P(array() As E P, ByVal start As Integer, ByVal end_ As Integer)
	If @array(0) <> NULL AndAlso UBound(array) >= start Then
		If end_ > UBound(array) Then
			end_ = UBound(array)
		EndIf
		Dim As E P tempArray(0 To end_ - start)
		For i As Integer = 0 To end_ - start
			tempArray(i) = array(i + start)
		Next
		This.setArray(tempArray())
	EndIf
End Constructor

MODULE_SCOPE Sub mdArrayIterator##E##P.getArray(array() As E P)
	innerList.toArray(array())
End Sub

MODULE_SCOPE Function mdArrayIterator##E##P.getClass() As String
	Return UCase("mdArrayIterator(" & #E & IIf(Len(#P), ", " & #P, "") & ")")
End Function

MODULE_SCOPE Sub mdArrayIterator##E##P.setArray(array() As E P)
	If @array(0) <> NULL Then
		For i As Integer = LBound(array) To UBound(array)
			innerList.add(array(i))
		Next
		This.cur = innerList.iterator().cur
	EndIf
End Sub

#EndIf '__MDARRAYITERATOR_BI__

#EndMacro

#Define mdArrayIteratorDeclare(E, P...) mdArrayIteratorDeclarePtr(E, P)
