'mdCollection - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/Collection.html


#Include Once "md/lang/mdObject.bi"
#Include Once "md/util/mdIterator.bi"

#Define mdCollectionPtr(E, P) mdCollection##E##P
#Define mdCollection(E, P...) mdCollectionPtr(E, P)

#Macro mdCollectionDeclarePtr(E, P)

#Ifndef mdBasicNode##E##P
'#Define __MBBASICNODE__

Type mdBasicNode##E##P
	nex As mdBasicNode##E##P Ptr
	value As E P
End Type

#EndIf '__MBBASICNODE__

mdIteratorDeclarePtr(E, P)

#Ifndef mdCollection##E##P
'#Define __MDCOLLECTION_BI__

Type mdCollection##E##P Extends mdObject
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef element As E P)
	Declare Constructor (ByRef l As mdCollection##E##P)
	Declare Virtual Destructor ()
	
	Declare Virtual Function add(ByRef element As E P) As Boolean
	Declare Virtual Function addAll(ByRef c As mdCollection##E##P) As Boolean
	Declare Virtual Sub clear()
	'Declare Virtual Function clone() As mdObject
	'Declare Virtual Function contains(ByRef o As mdObject) As Boolean
	Declare Virtual Function contains(ByRef o As E P) As Boolean
	Declare Virtual Function containsAll(ByRef c As mdCollection##E##P) As Boolean
	'Declare Virtual Function equals(ByRef o As mdObject) As Boolean
	Declare Virtual Function equals(ByRef o As mdCollection##E##P) As Boolean
	Declare Virtual Function getClass() As String
	Declare Virtual Function hashCode() As Integer
	Declare Virtual Function isEmpty() As Boolean
	Declare Virtual Function iterator() As mdIterator##E##P
	Declare Virtual Function remove(ByVal index As Integer) As E P
	'Declare Virtual Function remove(ByRef o As mdObject) As Boolean
	Declare Virtual Function remove(ByRef o As E P) As Boolean
	Declare Virtual Function removeAll(ByRef c As mdCollection##E##P) As Boolean
	Declare Virtual Function retainAll(ByRef c As mdCollection##E##P) As Boolean
	'Declare Virtual Sub share(ByRef c As mdCollection##E##P)
	Declare Virtual Function size() As Integer
	Declare Virtual Function toArray(array() As E P) As Boolean
	Declare Virtual Function toString() As String
	
	Declare Virtual Operator Cast() As Integer
	Declare Virtual Operator Cast() As String
	Declare Virtual Operator Let(ByRef c As mdCollection##E##P)
	
#If __FB_MIN_VERSION__(0, 91, 0)
	Declare Virtual Operator [](ByVal index As Integer) ByRef As E P
#EndIf
	
	Protected:
	node As mdBasicNode##E##P Ptr
	'isShared As Boolean 'getting shared space will disallow an object to manipulate it
End Type

MODULE_SCOPE Constructor mdCollection##E##P()
	
End Constructor

MODULE_SCOPE Constructor mdCollection##E##P(ByRef element As E P)
	This.add(element)
End Constructor

MODULE_SCOPE Constructor mdCollection##E##P(ByRef l As mdCollection##E##P)
	This.addAll(l)
End Constructor

MODULE_SCOPE Destructor mdCollection##E##P()
	This.clear()
End Destructor

MODULE_SCOPE Function mdCollection##E##P.add(ByRef element As E P) As Boolean
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, prevNode
	While currentNode <> NULL
		prevNode = currentNode
		currentNode = currentNode->nex
	Wend
	
	currentNode = New mdBasicNode##E##P
	If currentNode = NULL Then
		Return FALSE
	Else
		currentNode->value = element
		If prevNode <> NULL Then
			prevNode->nex = currentNode
		EndIf
		If This.node = NULL Then
			This.node = currentNode
		EndIf
		Return TRUE
	EndIf
End Function

MODULE_SCOPE Function mdCollection##E##P.addAll(ByRef c As mdCollection##E##P) As Boolean
	Dim As E P temp()
	c.toArray(temp())
	If @temp(0) = NULL Then
		Return FALSE
	EndIf
	For i As Integer = LBound(temp) To UBound(temp)
		This.add(temp(i))
	Next
	Return TRUE
End Function

MODULE_SCOPE Sub mdCollection##E##P.clear()
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, nextNode
	While currentNode <> NULL
		nextNode = currentNode->nex
		Delete currentNode 'If This.isShared = FALSE Then Delete currentNode
		currentNode = nextNode
	Wend
	This.node = NULL
End Sub

'MODULE_SCOPE Function mdCollection##E##P.clone() As mdObject
'	Dim As mdCollection##E##P cl
'	Dim As mdBasicNode##E##P Ptr currentNode = This.node
'	While currentNode <> NULL
'		cl.add(currentNode->value)
'		currentNode = currentNode->nex
'	Wend
'	Return cl
'End Function

MODULE_SCOPE Function mdCollection##E##P.contains(ByRef o As E P) As Boolean
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		If currentNode->value = o Then
			Return TRUE
		EndIf
		currentNode = currentNode->nex
	Wend
	Return FALSE
End Function

MODULE_SCOPE Function mdCollection##E##P.containsAll(ByRef c As mdCollection##E##P) As Boolean
	Dim As E P temp()
	c.toArray(temp())
	For i As Integer = LBound(temp) To UBound(temp)
		If This.contains(temp(i)) = FALSE Then
			Return FALSE
		EndIf
	Next
	Return TRUE
End Function

MODULE_SCOPE Function mdCollection##E##P.equals(ByRef o As mdCollection##E##P) As Boolean
	Return This.toString() = o.toString()
End Function

MODULE_SCOPE Function mdCollection##E##P.getClass() As String
	Return UCase("mdCollection(" & #E & IIf(Len(#P), ", " & #P, "") & ")")
End Function

MODULE_SCOPE Function mdCollection##E##P.hashCode() As Integer
	Dim As Integer hash = 1
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		hash = 31 * hash + IIf(currentNode = NULL, 0, Cast(UInteger, currentNode) \ This.size())
		currentNode = currentNode->nex
	Wend
	Return hash
End Function

MODULE_SCOPE Function mdCollection##E##P.isEmpty() As Boolean
	Return This.size() = 0
End Function

MODULE_SCOPE Function mdCollection##E##P.iterator() As mdIterator##E##P
	Dim As mdIterator##E##P newIterator = This.node
	Return newIterator
End Function

MODULE_SCOPE Function mdCollection##E##P.remove(ByVal index As Integer) As E P
	Dim As Integer i = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, nextNode, prevNode
	While currentNode <> NULL
		If i = index Then
			Dim As E P value = currentNode->value
			nextNode = currentNode->nex
			If currentNode = This.node Then
				This.node = nextNode
			EndIf
			Delete currentNode 'If This.isShared = FALSE Then Delete currentNode
			currentNode = nextNode
			If prevNode <> NULL Then
				prevNode->nex = currentNode
			EndIf
			Return value
		EndIf
		
		i += 1
		prevNode = currentNode
		If currentNode <> NULL Then
			currentNode = currentNode->nex
		EndIf
	Wend
	Dim As E P tempRet
	Return tempRet
End Function

MODULE_SCOPE Function mdCollection##E##P.remove(ByRef o As E P) As Boolean
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, nextNode, prevNode
	While currentNode <> NULL
		If currentNode->value = o Then
			nextNode = currentNode->nex
			If currentNode = This.node Then
				This.node = nextNode
			EndIf
			Delete currentNode 'If This.isShared = FALSE Then Delete currentNode
			currentNode = nextNode
			If prevNode <> NULL Then
				prevNode->nex = currentNode
			EndIf
			Return TRUE
		EndIf
		prevNode = currentNode
		If currentNode <> NULL Then
			currentNode = currentNode->nex
		EndIf
	Wend
	Return FALSE
End Function

MODULE_SCOPE Function mdCollection##E##P.removeAll(ByRef c As mdCollection##E##P) As Boolean
	Dim As Integer cSize = c.size()
	
	If cSize = 0 OrElse This.size() = 0 Then
		Return FALSE
	EndIf
	
	Dim As E P temp()
	c.toArray(temp())
	For i As Integer = LBound(temp) To UBound(temp)
		If This.contains(temp(i)) Then
			This.remove(temp(i))
		EndIf
	Next
	Return TRUE
End Function

MODULE_SCOPE Function mdCollection##E##P.retainAll(ByRef c As mdCollection##E##P) As Boolean
	Dim As Integer thisSize = This.size()
	
	If thisSize = 0 OrElse c.size() = 0 Then
		Return FALSE
	EndIf
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, nextNode, prevNode
	While currentNode <> NULL
		nextNode = currentNode->nex
		If c.contains(currentNode->value) = FALSE Then
			If currentNode = This.node Then
				This.node = nextNode
			EndIf
			Delete currentNode 'If This.isShared = FALSE Then Delete currentNode
			If prevNode <> NULL Then
				prevNode->nex = nextNode
			EndIf
			If currentNode = This.node Then
				This.node = nextNode
			EndIf
		Else
			prevNode = currentNode
		EndIf
		currentNode = nextNode
	Wend
	Return TRUE
End Function

'MODULE_SCOPE Sub mdCollection##E##P.share(ByRef c As mdCollection##E##P)
'	This.clear()
'	This.node = c.node
'	This.isShared = TRUE
'End Sub

MODULE_SCOPE Function mdCollection##E##P.size() As Integer
	Dim As Integer count = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		count += 1
		currentNode = currentNode->nex
	Wend
	Return count
End Function

MODULE_SCOPE Function mdCollection##E##P.toArray(array() As E P) As Boolean
	Dim As Integer thisSize = This.size(), i = 0
	If thisSize = 0 Then
		Return FALSE
	EndIf
	
	ReDim array(0 To thisSize - 1)
	If @array(0) = NULL Then
		Return FALSE
	EndIf
	
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		array(i) = currentNode->value
		i += 1
		currentNode = currentNode->nex
	Wend
	Return TRUE
End Function

MODULE_SCOPE Function mdCollection##E##P.toString() As String
	Dim As String ret = "["
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		ret &= Str(currentNode->value)
		currentNode = currentNode->nex
		If currentNode <> NULL Then
			ret &= ", "
		EndIf
	Wend
	ret &= "]"
	Return ret
End Function

MODULE_SCOPE Operator mdCollection##E##P.Cast() As Integer
	Return This.hashCode()
End Operator

MODULE_SCOPE Operator mdCollection##E##P.Cast() As String
	Return This.toString()
End Operator

MODULE_SCOPE Operator mdCollection##E##P.Let(ByRef c As mdCollection##E##P)
	This.clear()
	This.addAll(c)
End Operator

#If __FB_MIN_VERSION__(0, 91, 0)
MODULE_SCOPE Operator mdCollection##E##P.[](ByVal index As Integer) ByRef As E P
	Dim As Integer i = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		If i = index Then
			Return currentNode->value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As mdBasicNode##E##P Ptr tempRet
	Return tempRet->value
End Operator
#EndIf

MODULE_SCOPE Operator = (ByRef lhs As mdCollection##E##P, ByRef rhs As mdCollection##E##P) As Boolean
	Return lhs.toString() = rhs.toString()
End Operator

#EndIf '__MDCOLLECTION_BI__

#EndMacro

#Define mdCollectionDeclare(E, P...) mdCollectionDeclarePtr(E, P)
