'mdEnumeration - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/Enumeration.html


#Include "md/lang/mdObject.bi"
#Include "md/lang/mdString.bi"
#Include "md/util/mdList.bi"

#Define mdEnumerationPtr(E, P) mdEnumeration##E##P
#Define mdEnumeration(E, P...) mdEnumerationPtr(E, P)

#Macro mdEnumerationDeclarePtr(E, P)

mdListDeclarePtr(E, P)

#Ifndef mdEnumeration##E##P
'#Define __MDENUMERATION_BI__

Type mdEnumeration##E##P Extends mdObject
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef enum_ As mdEnumeration##E##P)
	Declare Constructor (ByRef c As mdCollection##E##P)
	Declare Constructor (ByRef s As String)
	
	Declare Virtual Function getClass() As String
	Declare Virtual Function hasMoreElements() As Boolean
	Declare Virtual Function nextElement() As E P
	
	Protected:
	As mdListPtr(E, P) list
	As mdIteratorPtr(E, P) iterator
	As Integer index
End Type

MODULE_SCOPE Constructor mdEnumeration##E##P()
	
End Constructor

MODULE_SCOPE Constructor mdEnumeration##E##P(ByRef enum_ As mdEnumeration##E##P)
	This.list = enum_.list
	This.iterator = This.list.iterator()
End Constructor

MODULE_SCOPE Constructor mdEnumeration##E##P(ByRef c As mdCollection##E##P)
	This.list.addAll(c)
	This.iterator = This.list.iterator()
End Constructor

MODULE_SCOPE Constructor mdEnumeration##E##P(ByRef s As String)
	Dim As mdString tempString = s
	Dim As String tempArray()
	tempString.split(tempArray(), " ")
	For i As Integer = LBound(tempArray) To UBound(tempArray)
		This.list.add(Cast(E P, tempArray(i)))
	Next
	This.iterator = This.list.iterator()
End Constructor

MODULE_SCOPE Function mdEnumeration##E##P.getClass() As String
	Return UCase("mdEnumeration(" & #E & IIf(Len(#P), ", " & #P, "") & ")")
End Function

MODULE_SCOPE Function mdEnumeration##E##P.hasMoreElements() As Boolean
	Return iterator.hasNext()
End Function

MODULE_SCOPE Function mdEnumeration##E##P.nextElement() As E P
	Return iterator.nex()
End Function

#EndIf '__MDENUMERATION_BI__

#EndMacro

#Define mdEnumerationDeclare(E, P...) mdEnumerationDeclarePtr(E, P)
