'mdList - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/List.html


#Include Once "md/util/mdCollection.bi"

#Define mdListPtr(E, P) mdList##E##P
#Define mdList(E, P...) mdListPtr(E, P)

#Macro mdListDeclarePtr(E, P)

mdCollectionDeclarePtr(E, P)

#Ifndef mdList##E##P
'#Define __MDLIST_BI__

Type mdList##E##P Extends mdCollection##E##P
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef element As E P)
	Declare Constructor (ByRef l As mdCollection##E##P)
	
	Declare Virtual Function add(ByRef element As E P) As Boolean
	Declare Virtual Function add(ByVal index As Integer, ByRef element As E P) As Boolean
	Declare Virtual Function addAll(ByRef c As mdCollection##E##P) As Boolean
	Declare Virtual Function addAll(ByVal index As Integer, ByRef c As mdCollection##E##P) As Boolean
	Declare Virtual Function get(ByVal index As Integer) As E P
	Declare Virtual Function getClass() As String
	'Declare Virtual Function indexOf(ByRef o As mdObject) As Integer
	Declare Virtual Function indexOf(ByRef o As E P) As Integer
	'Declare Virtual Function lastIndexOf(ByRef o As mdObject) As Integer
	Declare Virtual Function lastIndexOf(ByRef o As E P) As Integer
	'Declare Virtual Function listIterator() As mdListIterator
	'Declare Virtual Function listIterator(ByVal index As Integer) As mdListIterator
	Declare Virtual Function set(ByVal index As Integer, ByRef element As E P) As E P
	Declare Virtual Function subList(ByVal fromIndex As Integer, ByVal toIndex As Integer) As mdList##E##P
	
	Declare Virtual Operator Cast() As Integer
	Declare Virtual Operator Cast() As String
	Declare Virtual Operator Let(ByRef c As mdCollection##E##P)
	
#If __FB_MIN_VERSION__(0, 91, 0)
	Declare Virtual Operator [](ByVal index As Integer) ByRef As E P
#EndIf
End Type

MODULE_SCOPE Constructor mdList##E##P()
	
End Constructor

MODULE_SCOPE Constructor mdList##E##P(ByRef element As E P)
	This.add(element)
End Constructor

MODULE_SCOPE Constructor mdList##E##P(ByRef l As mdCollection##E##P)
	This.addAll(l)
End Constructor

MODULE_SCOPE Function mdList##E##P.add(ByRef element As E P) As Boolean
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, prevNode
	While currentNode <> NULL
		prevNode = currentNode
		currentNode = currentNode->nex
	Wend
	
	currentNode = New mdBasicNode##E##P
	If currentNode = NULL Then
		Return FALSE
	Else
		currentNode->value = element
		If prevNode <> NULL Then
			prevNode->nex = currentNode
		EndIf
		If This.node = NULL Then
			This.node = currentNode
		EndIf
		Return TRUE
	EndIf
End Function

MODULE_SCOPE Function mdList##E##P.add(ByVal index As Integer, ByRef element As E P) As Boolean
	Dim As Integer i = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, nextNode, prevNode, newNode
	While currentNode <> NULL
		If i = index Then
			nextNode = currentNode
			newNode = New mdBasicNode##E##P
			If newNode = NULL Then
				Return FALSE
			Else
				newNode->value = element
				newNode->nex = currentNode
				If prevNode <> NULL Then
					prevNode->nex = newNode
				EndIf
				If This.node = currentNode Then
					This.node = newNode
				EndIf
				Return TRUE
			EndIf
		EndIf
		
		i += 1
		prevNode = currentNode
		currentNode = currentNode->nex
	Wend
	
	Return FALSE
End Function

MODULE_SCOPE Function mdList##E##P.addAll(ByRef c As mdCollection##E##P) As Boolean
	Dim As E P temp()
	c.toArray(temp())
	If @temp(0) = NULL Then
		Return FALSE
	EndIf
	For i As Integer = LBound(temp) To UBound(temp)
		This.add(temp(i))
	Next
	Return TRUE
End Function

MODULE_SCOPE Function mdList##E##P.addAll(ByVal index As Integer, ByRef c As mdCollection##E##P) As Boolean
	If index < 0 OrElse This.size() < index Then
		Return FALSE
	EndIf
	Dim As E P temp()
	c.toArray(temp())
	If @temp(0) = NULL Then
		Return FALSE
	EndIf
	For i As Integer = 0 To UBound(temp)
		This.add(index + i, temp(i))
	Next
	Return TRUE
End Function

MODULE_SCOPE Function mdList##E##P.get(ByVal index As Integer) As E P
	Dim As Integer i = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		If i = index Then
			Return currentNode->value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As E P tempRet
	Return tempRet
End Function

MODULE_SCOPE Function mdList##E##P.getClass() As String
	Return UCase("mdList(" & #E & IIf(Len(#P), ", " & #P, "") & ")")
End Function

MODULE_SCOPE Function mdList##E##P.indexOf(ByRef o As E P) As Integer
	Dim As Integer i = -1, retIndex = -1
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		i += 1
		If currentNode->value = o Then
			retIndex = i
			Exit While
		EndIf
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

MODULE_SCOPE Function mdList##E##P.lastIndexOf(ByRef o As E P) As Integer
	Dim As Integer i = 0, retIndex = -1
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		If currentNode->value = o Then
			retIndex = i
		EndIf
		i += 1
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

MODULE_SCOPE Function mdList##E##P.set(ByVal index As Integer, ByRef element As E P) As E P
	Dim As Integer i = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode->nex <> NULL
		If i = index Then
			Dim As E P value = currentNode->value
			currentNode->value = element
			Return value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As E P tempRet
	Return tempRet
End Function

MODULE_SCOPE Function mdList##E##P.subList(ByVal fromIndex As Integer, ByVal toIndex As Integer) As mdList##E##P
	Dim As Integer i = 0
	Dim As mdList##E##P newmdList
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		If i >= fromIndex And i <= toIndex Then
			newmdList.add(currentNode->value)
		EndIf
		i += 1
		currentNode = currentNode->nex
	Wend
	Return newmdList
End Function

MODULE_SCOPE Operator mdList##E##P.Cast() As Integer
	Return This.hashCode()
End Operator

MODULE_SCOPE Operator mdList##E##P.Cast() As String
	Return This.toString()
End Operator

MODULE_SCOPE Operator mdList##E##P.Let(ByRef c As mdCollection##E##P)
	This.clear()
	This.addAll(c)
End Operator

#If __FB_MIN_VERSION__(0, 91, 0)
MODULE_SCOPE Operator mdList##E##P.[](ByVal index As Integer) ByRef As E P
	Dim As Integer i = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		If i = index Then
			Return currentNode->value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As mdBasicNode##E##P Ptr tempRet
	Return tempRet->value
End Operator
#EndIf

MODULE_SCOPE Operator = (ByRef lhs As mdList##E##P, ByRef rhs As mdList##E##P) As Boolean
	Return lhs.toString() = rhs.toString()
End Operator

#EndIf '__MDLIST_BI__

#EndMacro

#Define mdListDeclare(E, P...) mdListDeclarePtr(E, P)
