'mdMap - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/Map.html


#Include Once "md/util/mdCollection.bi"
#Include Once "md/util/mdSet.bi"

#Define mdMapEntryPtrPtr(K, PK, V, PV) mdMapEntry##K##PK##V##PV
#Define mdMapEntryPtr(K, PK, V, PV) mdMapEntryPtrPtr(K, PK, V, PV)
#Define mdMapEntry(K, V) mdMapEntryPtrPtr(K, , V, )

#Define mdMapPtr(K, PK, V, PV) mdMap##K##PK##V##PV
#Define mdMap(K, V) mdMapPtr(K, , V, )

#Macro mdMapDeclarePtrPtr(K, PK, V, PV)

mdCollectionDeclarePtr(V, PV)
mdSetDeclarePtr(K, PK)

#Ifndef mdMapEntry##K##PK##V##PV
'#Define __MDMAPENTRY__

Type mdMapEntry##K##PK##V##PV Extends mdObject
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef key As K PK, ByRef value As V PV)
	'Declare Virtual Function equals(ByRef o As mdObject) As Boolean
	Declare Virtual Function equals(ByRef o As mdMapEntry##K##PK##V##PV) As Boolean
	Declare Virtual Function getClass() As String
	Declare Virtual Function getKey() As K PK
	Declare Virtual Function getValue() As V PV
	Declare Virtual Function hashCode() As Integer
	Declare Virtual Function setValue(ByRef value As V PV) As V PV
	Declare Virtual Function toString() As String
	
	Declare Virtual Operator Cast() As String
	
#If __FB_MIN_VERSION__(0, 91, 0)
	Declare Virtual Operator [](ByRef key As K PK) ByRef As V PV
#EndIf
	
	Protected:
	As K PK key
	As V PV value
End Type

MODULE_SCOPE Constructor mdMapEntry##K##PK##V##PV()
	
End Constructor

MODULE_SCOPE Constructor mdMapEntry##K##PK##V##PV(ByRef key As K PK, ByRef value As V PV)
	This.key = key
	This.value = value
End Constructor

'MODULE_SCOPE Function mdMapEntry##K##PK##V##PV.equals(ByRef o As mdObject) As Boolean

MODULE_SCOPE Function mdMapEntry##K##PK##V##PV.equals(ByRef o As mdMapEntry##K##PK##V##PV) As Boolean
	If o.getKey() = This.key And o.getValue() = This.value Then
		Return TRUE
	EndIf
	Return FALSE
End Function

MODULE_SCOPE Function mdMapEntry##K##PK##V##PV.getClass() As String
	Return UCase("mdMapEntry(" & #K & ", " & IIf(Len(#PK) OrElse Len(#PV), #PK, #V) & IIf(Len(#PK) OrElse Len(#PV), ", " & #V & ", " & #PV, "") & ")")
End Function

MODULE_SCOPE Function mdMapEntry##K##PK##V##PV.getKey() As K PK
	Return This.key
End Function

MODULE_SCOPE Function mdMapEntry##K##PK##V##PV.getValue() As V PV
	Return This.value
End Function

MODULE_SCOPE Function mdMapEntry##K##PK##V##PV.hashCode() As Integer
	Return Cast(Integer, @This)
End Function

MODULE_SCOPE Function mdMapEntry##K##PK##V##PV.setValue(ByRef value As V PV) As V PV
	Dim As V PV tempValue = This.value
	This.value = value
	Return tempValue
End Function

MODULE_SCOPE Function mdMapEntry##K##PK##V##PV.toString() As String
	Return Str(This.key) & "=" & Str(This.value)
End Function

MODULE_SCOPE Operator mdMapEntry##K##PK##V##PV.Cast() As String
	Return This.toString()
End Operator

#If __FB_MIN_VERSION__(0, 91, 0)
MODULE_SCOPE Operator mdMapEntry##K##PK##V##PV.[](ByRef key As K PK) ByRef As V PV
	Return This.value
End Operator
#EndIf

MODULE_SCOPE Operator = (ByRef lhs As mdMapEntry##K##PK##V##PV, ByRef rhs As mdMapEntry##K##PK##V##PV) As Integer
	Return @lhs = @rhs
End Operator

mdSetDeclare(mdMapEntry##K##PK##V##PV)

#EndIf '__MDMAPENTRY__

#Ifndef mdMapNode##K##PK##V##PV
'#Define __MDMAPNODE__

Type mdMapNode##K##PK##V##PV
	nex As mdMapNode##K##PK##V##PV Ptr
	value As mdMapEntry##K##PK##V##PV
End Type

#EndIf '__MDMAPNODE__

#Ifndef mdMap##K##PK##V##PV
'#Define __MDMAP_BI__

Type mdMap##K##PK##V##PV Extends mdObject
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef m As mdMap##K##PK##V##PV)
	Declare Virtual Destructor ()
	Declare Virtual Sub clear()
	'Declare Virtual Function containsKey(ByRef key As mdObject) As Boolean
	Declare Virtual Function containsKey(ByRef key As K PK) As Boolean
	'Declare Virtual Function containsValue(ByRef value As mdObject) As Boolean
	Declare Virtual Function containsValue(ByRef value As V PV) As Boolean
	Declare Virtual Function entrySet() As mdSet(mdMapEntry##K##PK##V##PV)
	'Declare Virtual Function equals(ByRef o As mdObject) As Boolean
	Declare Virtual Function equals(ByRef o As mdMap##K##PK##V##PV) As Boolean
	'Declare Virtual Function get(ByRef key As mdObject) As V PV
	Declare Virtual Function get(ByRef key As K PK) As V PV
	Declare Virtual Function getClass() As String
	Declare Virtual Function hashCode() As Integer
	Declare Virtual Function isEmpty() As Boolean
	Declare Virtual Function keySet() As mdSet##K##PK
	Declare Virtual Function put(ByRef key As K PK, ByRef value As V PV) As V PV
	Declare Virtual Sub putAll(ByRef m As mdMap##K##PK##V##PV)
	'Declare Virtual Function remove(ByRef key As mdObject) As V PV
	Declare Virtual Function remove(ByRef key As K PK) As V PV
	'Declare Virtual Sub share(ByRef map As mdMap##K##PK##V##PV)
	Declare Virtual Function size() As Integer
	Declare Virtual Function toString() As String
	Declare Virtual Function values() As mdCollection##V##PV
	
	Declare Virtual Operator Cast() As Integer
	Declare Virtual Operator Cast() As String
	Declare Virtual Operator Let(ByRef c As mdMap##K##PK##V##PV)
	
#If __FB_MIN_VERSION__(0, 91, 0)
	Declare Virtual Operator [](ByVal key As K PK) ByRef As V PV
#EndIf
	
	Protected:
	node As mdMapNode##K##PK##V##PV Ptr
	'isShared As Boolean 'getting shared space will disallow an object to delete the memory by itself
End Type

MODULE_SCOPE Constructor mdMap##K##PK##V##PV()
	
End Constructor

MODULE_SCOPE Constructor mdMap##K##PK##V##PV(ByRef m As mdMap##K##PK##V##PV)
	This.putAll(m)
End Constructor

MODULE_SCOPE Destructor mdMap##K##PK##V##PV()
	This.clear()
End Destructor

MODULE_SCOPE Sub mdMap##K##PK##V##PV.clear()
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node, nextNode
	While currentNode <> NULL
		nextNode = currentNode->nex
		Delete currentNode 'If This.isShared = FALSE Then Delete currentNode
		currentNode = nextNode
	Wend
	This.node = NULL
End Sub

'MODULE_SCOPE Function mdMap##K##PK##V##PV.containsKey(ByRef key As mdObject) As Boolean

MODULE_SCOPE Function mdMap##K##PK##V##PV.containsKey(ByRef key As K PK) As Boolean
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node
	While currentNode <> NULL
		If currentNode->value.getKey() = key Then
			Return TRUE
		EndIf
		currentNode = currentNode->nex
	Wend
	Return FALSE
End Function

'MODULE_SCOPE Function mdMap##K##PK##V##PV.containsValue(ByRef value As mdObject) As Boolean

MODULE_SCOPE Function mdMap##K##PK##V##PV.containsValue(ByRef value As V PV) As Boolean
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node
	While currentNode <> NULL
		If currentNode->value.getValue() = value Then
			Return TRUE
		EndIf
		currentNode = currentNode->nex
	Wend
	Return FALSE
End Function

MODULE_SCOPE Function mdMap##K##PK##V##PV.entrySet() As mdSet(mdMapEntry##K##PK##V##PV)
	Dim As mdSet(mdMapEntry##K##PK##V##PV) newmdSet
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node
	While currentNode <> NULL
		newmdSet.add(currentNode->value)
		currentNode = currentNode->nex
	Wend
	Return newmdSet
End Function

'MODULE_SCOPE Function mdMap##K##PK##V##PV.equals(ByRef o As mdObject) As Boolean

MODULE_SCOPE Function mdMap##K##PK##V##PV.equals(ByRef o As mdMap##K##PK##V##PV) As Boolean
	Return This.toString() = o.toString()
End Function

'MODULE_SCOPE Function mdMap##K##PK##V##PV.get(ByRef key As mdObject) As V PV

MODULE_SCOPE Function mdMap##K##PK##V##PV.get(ByRef key As K PK) As V PV
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node
	While currentNode <> NULL
		If currentNode->value.getKey() = key Then
			Return currentNode->value.getValue()
		EndIf
		currentNode = currentNode->nex
	Wend
	Dim As V PV emptyValue
	Return emptyValue
End Function

MODULE_SCOPE Function mdMap##K##PK##V##PV.getClass() As String
	Return UCase("mdMap(" & #K & ", " & IIf(Len(#PK) OrElse Len(#PV), #PK, #V) & IIf(Len(#PK) OrElse Len(#PV), ", " & #V & ", " & #PV, "") & ")")
End Function

MODULE_SCOPE Function mdMap##K##PK##V##PV.hashCode() As Integer
	Dim As Integer hash = 1
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node
	While currentNode <> NULL
		hash = 31 * hash + IIf(currentNode = NULL, 0, Cast(UInteger, currentNode) \ This.size())
		currentNode = currentNode->nex
	Wend
	Return hash
End Function

MODULE_SCOPE Function mdMap##K##PK##V##PV.isEmpty() As Boolean
	Return This.size() = 0
End Function

MODULE_SCOPE Function mdMap##K##PK##V##PV.keySet() As mdSet##K##PK
	Dim As mdSet##K##PK newSet
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node
	While currentNode <> NULL
		newSet.add(currentNode->value.getKey())
		currentNode = currentNode->nex
	Wend
	Return newSet
End Function

MODULE_SCOPE Function mdMap##K##PK##V##PV.put(ByRef key As K PK, ByRef value As V PV) As V PV
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node, prevNode
	While currentNode <> NULL
		If currentNode->value.getKey() = key Then
			Dim As V PV tempValue = currentNode->value.getValue(), unusedValue
			unusedValue = currentNode->value.setValue(value)
			Return tempValue
		EndIf
		currentNode = currentNode->nex
	Wend
	
	Dim As mdMapEntry##K##PK##V##PV Ptr newEntry = New mdMapEntry##K##PK##V##PV(key, value)
	If newEntry <> NULL Then
		currentNode = This.node
		While currentNode <> NULL
			prevNode = currentNode
			currentNode = currentNode->nex
		Wend
		
		currentNode = New mdMapNode##K##PK##V##PV
		If currentNode <> NULL Then
			currentNode->value = *newEntry
			If prevNode <> NULL Then
				prevNode->nex = currentNode
			EndIf
			If This.node = NULL Then
				This.node = currentNode
			EndIf
		EndIf
	EndIf
	Dim As V PV emptyValue
	Return emptyValue
End Function

MODULE_SCOPE Sub mdMap##K##PK##V##PV.putAll(ByRef m As mdMap##K##PK##V##PV)
	Dim As mdSet##K##PK newSet = m.keySet()
	Dim As mdCollection##V##PV newCollection = m.values()
	Dim As V PV valueArray()
	newCollection.toArray(valueArray())
	
	Dim As Integer i = 0
	Dim As V PV tempValue
	Dim As K PK key
	ForEach (K, key In newSet, PK)
		tempValue = This.put(key, valueArray(i))
		i += 1
	NextEach
End Sub

'MODULE_SCOPE Function mdMap##K##PK##V##PV.remove(ByRef key As mdObject) As V PV

MODULE_SCOPE Function mdMap##K##PK##V##PV.remove(ByRef key As K PK) As V PV
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node, nextNode, prevNode
	While currentNode <> NULL
		If currentNode->value.getKey() = key Then
			Dim As V PV tempValue = currentNode->value.getValue()
			nextNode = currentNode->nex
			If currentNode = This.node Then
				This.node = nextNode
			EndIf
			Delete currentNode 'If This.isShared = FALSE Then Delete currentNode
			currentNode = nextNode
			If prevNode <> NULL Then
				prevNode->nex = currentNode
			EndIf
			Return tempValue
		EndIf
		
		prevNode = currentNode
		If currentNode <> NULL Then
			currentNode = currentNode->nex
		EndIf
	Wend
	Dim As V PV emptyValue
	Return emptyValue
End Function

'MODULE_SCOPE Sub mdMap##K##PK##V##PV.share(ByRef map As mdMap##K##PK##V##PV)
'	This.clear()
'	This.node = map.node
'	This.isShared = TRUE
'End Sub

MODULE_SCOPE Function mdMap##K##PK##V##PV.size() As Integer
	Dim As Integer count = 0
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node
	While currentNode <> NULL
		count += 1
		currentNode = currentNode->nex
	Wend
	Return count
End Function

MODULE_SCOPE Function mdMap##K##PK##V##PV.toString() As String
	Dim As String ret = "{"
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node
	While currentNode <> NULL
		ret &= Str(currentNode->value)
		currentNode = currentNode->nex
		If currentNode <> NULL Then
			ret &= ", "
		EndIf
	Wend
	ret &= "}"
	Return ret
End Function

MODULE_SCOPE Function mdMap##K##PK##V##PV.values() As mdCollection##V##PV
	Dim As mdCollection##V##PV newCollection
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node
	While currentNode <> NULL
		newCollection.add(currentNode->value.getValue())
		currentNode = currentNode->nex
	Wend
	Return newCollection
End Function

MODULE_SCOPE Operator mdMap##K##PK##V##PV.Cast() As Integer
	Return This.hashCode()
End Operator

MODULE_SCOPE Operator mdMap##K##PK##V##PV.Cast() As String
	Return This.toString()
End Operator

MODULE_SCOPE Operator mdMap##K##PK##V##PV.Let(ByRef c As mdMap##K##PK##V##PV)
	This.clear()
	This.putAll(c)
End Operator

#If __FB_MIN_VERSION__(0, 91, 0)
MODULE_SCOPE Operator mdMap##K##PK##V##PV.[](ByVal key As K PK) ByRef As V PV
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node
	While currentNode <> NULL
		If currentNode->value.getKey() = key Then
			Return currentNode->value[key]
		EndIf
		currentNode = currentNode->nex
	Wend
	Dim As mdMapNode##K##PK##V##PV Ptr emptyValue
	Return emptyValue->value[key]
End Operator
#EndIf

MODULE_SCOPE Operator = (ByRef lhs As mdMap##K##PK##V##PV, ByRef rhs As mdMap##K##PK##V##PV) As Boolean
	Return lhs.toString() = rhs.toString()
End Operator

#EndIf '__MDMAP_BI__

#EndMacro

#Define mdMapDeclare(K, V) mdMapDeclarePtrPtr(K, , V, )
#Define mdMapDeclarePtr(K, PK, V, PV) mdMapDeclarePtrPtr(K, PK, V, PV)
