'mdProperties - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/Properties.html


#Include Once "md/util/mdHashtable.bi"
#Include Once "md/util/mdSet.bi"

#Ifndef __MDPROPERTIES_BI__
#Define __MDPROPERTIES_BI__

mdSetDeclare(String)
mdHashtableDeclare(String String)
mdEnumerationDeclare(String)

Type mdProperties Extends mdHashtable(String, String)
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef defaults As mdProperties)
	
	Declare Virtual Function getClass() As String
	Declare Virtual Function getProperty(ByRef key As String) As String
	Declare Virtual Function getProperty(ByRef key As String, ByRef defaultValue As String) As String
	'Declare Virtual Sub list(ByRef out As mdPrintStream)
	'Declare Virtual Sub list(ByRef out As mdPrintWriter)
	Declare Virtual Sub list(ByVal fileNumber As Integer)
	Declare Virtual Sub list(ByRef fileName As String)
	Declare Virtual Sub list() 'console
	'Declare Virtual Sub load(ByRef inStream As mdInputStream)
	'Declare Virtual Sub load(ByRef reader As mdReader)
	Declare Virtual Sub load(ByVal fileNumber As Integer)
	Declare Virtual Sub load(ByRef fileName As String)
	'Declare Virtual Sub loadFromXML(ByRef ins As mdInputStream)
	Declare Virtual Sub loadFromXML(ByVal fileNumber As Integer)
	Declare Virtual Sub loadFromXML(ByRef fileName As String)
	Declare Virtual Function propertyNames() As mdEnumeration(String)
	'Declare Virtual Sub save(ByRef o As mdOutputStream, ByRef comments As string)
	Declare Virtual Sub save(ByVal fileNumber As Integer, ByRef comments As String)
	Declare Virtual Sub save(ByRef fileName As String, ByRef comments As String)
	Declare Virtual Function setProperty(ByRef key As String, ByRef value As String) As String
	'Declare Virtual Sub store(ByRef o As mdOutputStream, ByRef comments As string)
	'Declare Virtual Sub store(ByRef writer As mdWriter, ByRef comments As string)
	Declare Virtual Sub store(ByVal fileNumber As Integer, ByRef comments As String)
	Declare Virtual Sub store(ByRef fileName As String, ByRef comments As String)
	'Declare Virtual Sub storeToXML(ByRef o As mdOutputStream, ByRef comments As string)
	'Declare Virtual Sub storeToXML(ByRef o As mdOutputStream, ByRef comments As string, ByRef encoding_ As string)
	Declare Virtual Sub storeToXML(ByVal fileNumber As Integer, ByRef comments As String)
	Declare Virtual Sub storeToXML(ByVal fileNumber As Integer, ByRef comments As String, ByRef encoding_ As String)
	Declare Virtual Sub storeToXML(ByRef fileName As String, ByRef comments As String)
	Declare Virtual Sub storeToXML(ByRef fileName As String, ByRef comments As String, ByRef encoding_ As String)
	Declare Virtual Function stringPropertyNames() As mdSet(String)
End Type

MODULE_SCOPE Constructor mdProperties()
	
End Constructor

MODULE_SCOPE Constructor mdProperties(ByRef defaults As mdProperties)
	This = defaults
End Constructor

MODULE_SCOPE Function mdProperties.getClass() As String
	Return UCase("mdProperties")
End Function

MODULE_SCOPE Function mdProperties.getProperty(ByRef key As String) As String
	Return This.getValue(key)
End Function

MODULE_SCOPE Function mdProperties.getProperty(ByRef key As String, ByRef defaultValue As String) As String
	Dim As String ret = This.getValue(key)
	If ret = "" Then
		ret = defaultValue
	EndIf
	Return ret
End Function

'MODULE_SCOPE Sub mdProperties.list(ByRef out As mdPrintStream)

'MODULE_SCOPE Sub mdProperties.list(ByRef out As mdPrintWriter)

MODULE_SCOPE Sub mdProperties.list(ByVal fileNumber As Integer)
	
End Sub

MODULE_SCOPE Sub mdProperties.list(ByRef fileName As String)
	
End Sub

MODULE_SCOPE Sub mdProperties.list() 'console
	
End Sub

'MODULE_SCOPE Sub mdProperties.load(ByRef inStream As mdInputStream)

'MODULE_SCOPE Sub mdProperties.load(ByRef reader As mdReader)

MODULE_SCOPE Sub mdProperties.load(ByVal fileNumber As Integer)
	
End Sub

MODULE_SCOPE Sub mdProperties.load(ByRef fileName As String)
	
End Sub

'MODULE_SCOPE Sub mdProperties.loadFromXML(ByRef ins As mdInputStream)

MODULE_SCOPE Sub mdProperties.loadFromXML(ByVal fileNumber As Integer)
	
End Sub

MODULE_SCOPE Sub mdProperties.loadFromXML(ByRef fileName As String)
	
End Sub

MODULE_SCOPE Function mdProperties.propertyNames() As mdEnumeration(String)
	Return This.values()
End Function

'MODULE_SCOPE Sub mdProperties.save(ByRef o As mdOutputStream, ByRef comments As string)

MODULE_SCOPE Sub mdProperties.save(ByVal fileNumber As Integer, ByRef comments As String)
	
End Sub

MODULE_SCOPE Sub mdProperties.save(ByRef fileName As String, ByRef comments As String)
	
End Sub

MODULE_SCOPE Function mdProperties.setProperty(ByRef key As String, ByRef value As String) As String
	Return This.put(key, value)
End Function

'MODULE_SCOPE Sub mdProperties.store(ByRef o As mdOutputStream, ByRef comments As string)

'MODULE_SCOPE Sub mdProperties.store(ByRef writer As mdWriter, ByRef comments As string)

MODULE_SCOPE Sub mdProperties.store(ByVal fileNumber As Integer, ByRef comments As String)
	
End Sub

MODULE_SCOPE Sub mdProperties.store(ByRef fileName As String, ByRef comments As String)
	
End Sub

'MODULE_SCOPE Sub mdProperties.storeToXML(ByRef o As mdOutputStream, ByRef comments As string)

'MODULE_SCOPE Sub mdProperties.storeToXML(ByRef o As mdOutputStream, ByRef comments As string, ByRef encoding_ As string)

MODULE_SCOPE Sub mdProperties.storeToXML(ByVal fileNumber As Integer, ByRef comments As String)
	
End Sub

MODULE_SCOPE Sub mdProperties.storeToXML(ByVal fileNumber As Integer, ByRef comments As String, ByRef encoding_ As String)
	
End Sub

MODULE_SCOPE Sub mdProperties.storeToXML(ByRef fileName As String, ByRef comments As String)
	
End Sub

MODULE_SCOPE Sub mdProperties.storeToXML(ByRef fileName As String, ByRef comments As String, ByRef encoding_ As String)
	
End Sub

MODULE_SCOPE Function mdProperties.stringPropertyNames() As mdSet(String)
	Return This.keySet()
End Function

#EndIf '__MDPROPERTIES_BI__
