'mdResourceBundle - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/ResourceBundle.html


#Ifndef SEPARATOR
	#If Defined(__FB_WIN32__)
		#Define SEPARATOR "\"
	#ElseIf Defined(__FB_LINUX__)
		#Define SEPARATOR "/"
	#EndIf
#EndIf

#Include Once "md/lang/mdObject.bi"
#Include Once "md/util/mdList.bi"
#Include Once "md/util/mdSet.bi"
#Include Once "md/util/mdMap.bi"
#Include Once "md/lang/mdString.bi"

mdListDeclare(String)
mdSetDeclare(String)
mdMapDeclare(String, String)


#Ifndef __MDRESOURCEBUNDLE_BI__
#Define __MDRESOURCEBUNDLE_BI__

Type mdResourceBundleControl Extends mdObject
	
End Type

Type mdResourceBundleParent As mdResourceBundle

Type mdResourceBundle Extends mdObject
	Public:
	Declare Constructor ()
	
	'Declare Virtual Sub clearCache()
	'Declare Virtual Sub clearCache(ByRef loader As mdClassLoader)
	Declare Virtual Function containsKey(ByRef key As String) As Boolean
	Declare Static Function getBundle(ByRef baseName As String) ByRef As mdResourceBundle
	Declare Static Function getBundle(ByRef baseName As String, ByRef locale As String) ByRef As mdResourceBundle
	'Declare Static Function getBundle(ByRef baseName As String, ByRef locale As mdLocale) As mdResourceBundle
	'Declare Static Function getBundle(ByRef baseName As String, ByRef locale As mdLocale, ByRef loader As mdClassLoader) As mdResourceBundle
	'Declare Static Function getBundle(ByRef baseName As String, ByRef targetLocale As mdLocale, ByRef loader As mdClassLoader, ByRef control As mdResourceBundleControl) As mdResourceBundle
	'Declare Static Function getBundle(ByRef baseName As String, ByRef targetLocale As mdLocale, ByRef control As mdResourceBundleControl) As mdResourceBundle
	'Declare Static Function getBundle(ByRef baseName As String, ByRef control As mdResourceBundleControl) As mdResourceBundle
	'Declare Virtual /'Abstract'/ Function getKeys() As mdEnumeration(String)
	Declare Function getLocale() As String
	'Declare Function getLocale() As mdLocale
	'Declare Function getObject(ByRef key As String) As mdObject
	Declare Virtual Function getString(ByRef key As String) As String
	Declare Virtual Function getString(ByRef key As String, array() As String) As String
	Declare Virtual Function getString(ByRef key As String, ByRef replace As String) As String
	Declare Virtual Function getStringArray(ByRef key As String, array() As String) As Boolean
	Declare Virtual Function keySet() As mdSet(String)
	Declare Virtual Sub setParent(ByRef parent As mdResourceBundle)
	Declare Virtual Function getStringList(ByRef key As String) As mdList(String)
	
	Protected:
	'Declare Constructor ()
	
	'Declare Virtual Function handleGetObject(ByRef key As String) As mdObject
	Declare Virtual Function handleKeySet() As mdSet(String)
	'Declare Virtual Sub setParent(ByRef parent As mdResourceBundle) -> make it public
	
	As mdMap(String, String) keyValueMap
	As mdResourceBundleParent Ptr parent
	As String locale
End Type

MODULE_SCOPE Constructor mdResourceBundle()
	
End Constructor

'MODULE_SCOPE Sub mdResourceBundle.clearCache()
'	
'End Sub

'MODULE_SCOPE Sub mdResourceBundle.clearCache(ByRef loader As mdClassLoader)
'	
'End Sub

MODULE_SCOPE Function mdResourceBundle.containsKey(ByRef key As String) As Boolean
	Dim As Boolean ret = This.keyValueMap.containsKey(key)
	If ret = FALSE AndAlso This.parent <> NULL Then
		ret = This.parent->containsKey(key)
	EndIf
	Return ret
End Function

MODULE_SCOPE Function mdResourceBundle.getBundle(ByRef baseName As String) ByRef As mdResourceBundle
	Return mdResourceBundle.getBundle(baseName, "")
End Function

MODULE_SCOPE Function mdResourceBundle.getBundle(ByRef baseName As String, ByRef locale As String) ByRef As mdResourceBundle
	Dim As mdResourceBundle Ptr rb = New mdResourceBundle()
	
	Dim As String tempString, tempPath = baseName & IIf(Len(locale), "_" & locale, "") & ".properties"
	Dim As Integer FF
	Dim As mdString tempmdString
	
	FF = FreeFile
	If Open(ExePath & SEPARATOR & tempPath For Input As #FF) <> 0 Then
		Print "Error: Can't load language file " & tempPath
		Return *rb
	Else
		While Not Eof(FF)
			Dim As String tempArray()
			Line Input #FF, tempString
			If Len(tempString) Then
				If Not Left(Trim(tempString, Any !" \t\n\r"), 1) = "#" Then
					tempmdString = tempString
					tempmdString.split(tempArray(), "=", 2)
					If UBound(tempArray) = 1 Then
						tempString = rb->keyValueMap.put(Trim(tempArray(0), Any !" \t"), Trim(tempArray(1), Any !" \t"))
					EndIf
				EndIf
			EndIf
		Wend
		Close #FF
	EndIf
	
	rb->locale = locale
	Return *rb
End Function

'MODULE_SCOPE Function mdResourceBundle.getBundle(ByRef baseName As String, ByRef locale As mdLocale) As mdResourceBundle
'	
'End Function

'MODULE_SCOPE Function mdResourceBundle.getBundle(ByRef baseName As String, ByRef locale As mdLocale, ByRef loader As mdClassLoader) As mdResourceBundle
'	
'End Function

'MODULE_SCOPE Function mdResourceBundle.getBundle(ByRef baseName As String, ByRef targetLocale As mdLocale, ByRef loader As mdClassLoader, ByRef control As mdResourceBundleControl) As mdResourceBundle
'	
'End Function

'MODULE_SCOPE Function mdResourceBundle.getBundle(ByRef baseName As String, ByRef targetLocale As mdLocale, ByRef control As mdResourceBundleControl) As mdResourceBundle
'	
'End Function

'MODULE_SCOPE Function mdResourceBundle.getBundle(ByRef baseName As String, ByRef control As mdResourceBundleControl) As mdResourceBundle
'	
'End Function

'MODULE_SCOPE Function mdResourceBundle.getKeys() As mdEnumeration(String)
'	
'End Function

MODULE_SCOPE Function mdResourceBundle.getLocale() As String
	Return This.locale
End Function

'MODULE_SCOPE Function mdResourceBundle.getLocale() As mdLocale
'	
'End Function

'MODULE_SCOPE Function mdResourceBundle.getObject(ByRef key As String) As mdObject
'	
'End Function

MODULE_SCOPE Function mdResourceBundle.getString(ByRef key As String) As String
	Dim As String ret = This.keyValueMap.get(key)
	If Len(ret) = 0 AndAlso This.parent <> NULL Then
		ret = This.parent->getString(key)
	EndIf
	Return ret
End Function

MODULE_SCOPE Function mdResourceBundle.getString(ByRef key As String, array() As String) As String
	Dim As String ret = This.keyValueMap.get(key)
	If @array(0) <> NULL Then
		Dim As mdString tempString = ret
		
		For i As Integer = LBound(array) To UBound(array)
			tempString = tempString.replace("{" & Str(i) & "}", array(i))
		Next
		
		ret = tempString
	EndIf
	If Len(ret) = 0 AndAlso This.parent <> NULL Then
		ret = This.parent->getString(key, array())
	EndIf
	Return ret
End Function

MODULE_SCOPE Function mdResourceBundle.getString(ByRef key As String, ByRef replace As String) As String
	Dim As String array()
	Dim As mdString temp = replace
	temp.split(array(), " ")
	Return This.getString(key, array())
End Function

MODULE_SCOPE Function mdResourceBundle.getStringArray(ByRef key As String, array() As String) As Boolean
	Dim As mdList(String) retList
	Dim As String temp = This.keyValueMap.get(key)
	If Len(temp) <> 0 Then
		retList.add(temp)
	EndIf
	If This.parent <> NULL Then
		Dim As mdList(String) tempList = This.parent->getStringList(key)
		retList.addAll(tempList)
	EndIf
	ReDim array(0 To retList.size() - 1)
	For i As Integer = 0 To retList.size() - 1
		array(i) = retList.get(i)
	Next
	Return TRUE
End Function

MODULE_SCOPE Function mdResourceBundle.getStringList(ByRef key As String) As mdList(String)
	Dim As mdList(String) retList
	Dim As String temp = This.keyValueMap.get(key)
	If Len(temp) <> 0 Then
		retList.add(temp)
	EndIf
	If This.parent <> NULL Then
		Dim As mdList(String) tempList = This.parent->getStringList(key)
		retList.addAll(tempList)
	EndIf
	Return retList
End Function

MODULE_SCOPE Function mdResourceBundle.keySet() As mdSet(String)
	Dim As mdSet(String) keys = This.keyValueMap.keySet()
	If parent <> NULL Then
		Dim As mdSet(String) tempSet = This.parent->keySet()
		keys.addAll(tempSet)
	EndIf
	Return keys
End Function

'MODULE_SCOPE Function mdResourceBundle.handleGetObject(key As String) As mdObject
'	
'End Function

MODULE_SCOPE Function mdResourceBundle.handleKeySet() As mdSet(String)
	Return This.keyValueMap.keySet()
End Function

MODULE_SCOPE Sub mdResourceBundle.setParent(ByRef parent As mdResourceBundle)
	This.parent = @parent
End Sub

#EndIf '__MDRESOURCEBUNDLE_BI__
