'mdSet - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/Set.html


#Include Once "md/util/mdCollection.bi"

#Define mdSetPtr(E, P) mdSet##E##P
#Define mdSet(E, P...) mdSetPtr(E, P)

#Macro mdSetDeclarePtr(E, P)

mdCollectionDeclarePtr(E, P)

#Ifndef mdSet##E##P
'#Define __MDSET_BI__

Type mdSet##E##P Extends mdCollection##E##P
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef element As E P)
	Declare Constructor (ByRef s As mdCollection##E##P)
	
	Declare Virtual Function add(ByRef element As E P) As Boolean
	Declare Virtual Function addAll(ByRef c As mdCollection##E##P) As Boolean
	Declare Virtual Function getClass() As String
	
	Declare Virtual Operator Cast() As Integer
	Declare Virtual Operator Cast() As String
	Declare Virtual Operator Let(ByRef c As mdCollection##E##P)
	
#If __FB_MIN_VERSION__(0, 91, 0)
	Declare Virtual Operator [](ByVal index As Integer) ByRef As E P
#EndIf
End Type

MODULE_SCOPE Constructor mdSet##E##P()
	
End Constructor

MODULE_SCOPE Constructor mdSet##E##P(ByRef element As E P)
	This.add(element)
End Constructor

MODULE_SCOPE Constructor mdSet##E##P(ByRef s As mdCollection##E##P)
	This.addAll(s)
End Constructor

MODULE_SCOPE Function mdSet##E##P.add(ByRef element As E P) As Boolean
	If This.contains(element) Then
		Return FALSE
	EndIf
	
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, prevNode
	While currentNode <> NULL
		prevNode = currentNode
		currentNode = currentNode->nex
	Wend
	
	currentNode = New mdBasicNode##E##P
	If currentNode = NULL Then
		Return FALSE
	Else
		currentNode->value = element
		If prevNode <> NULL Then
			prevNode->nex = currentNode
		EndIf
		If This.node = NULL Then
			This.node = currentNode
		EndIf
		Return TRUE
	EndIf
End Function

MODULE_SCOPE Function mdSet##E##P.addAll(ByRef c As mdCollection##E##P) As Boolean
	Dim As E P temp()
	c.toArray(temp())
	If @temp(0) = NULL Then
		Return FALSE
	EndIf
	For i As Integer = LBound(temp) To UBound(temp)
		This.add(temp(i))
	Next
	Return TRUE
End Function

MODULE_SCOPE Function mdSet##E##P.getClass() As String
	Return UCase("mdSet(" & #E & IIf(Len(#P), ", " & #P, "") & ")")
End Function

MODULE_SCOPE Operator mdSet##E##P.Cast() As Integer
	Return This.hashCode()
End Operator

MODULE_SCOPE Operator mdSet##E##P.Cast() As String
	Return This.toString()
End Operator

MODULE_SCOPE Operator mdSet##E##P.Let(ByRef c As mdCollection##E##P)
	This.clear()
	This.addAll(c)
End Operator

#If __FB_MIN_VERSION__(0, 91, 0)
MODULE_SCOPE Operator mdSet##E##P.[](ByVal index As Integer) ByRef As E P
	Dim As Integer i = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		If i = index Then
			Return currentNode->value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As mdBasicNode##E##P Ptr tempRet
	Return tempRet->value
End Operator
#EndIf

MODULE_SCOPE Operator = (ByRef lhs As mdSet##E##P, ByRef rhs As mdSet##E##P) As Boolean
	Return lhs.toString() = rhs.toString()
End Operator

#EndIf '__MDSET_BI__

#EndMacro

#Define mdSetDeclare(E, P...) mdSetDeclarePtr(E, P)
