'mdStack - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/Stack.html


#Include Once "md/util/mdVector.bi"

#Define mdStackPtr(E, P) mdStack##E##P
#Define mdStack(E, P...) mdStackPtr(E, P)

#Macro mdStackDeclarePtr(E, P)

mdVectorDeclarePtr(E, P)

#Ifndef mdStack##E##P
'#Define __MDSTACK_BI__

Type mdStack##E##P Extends mdVector##E##P
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef element As E P)
	Declare Constructor (ByRef l As mdCollection##E##P)
	
	Declare Virtual Function empty() As Boolean
	Declare Virtual Function getClass() As String
	Declare Virtual Function peek_() As E P
	Declare Virtual Function pop() As E P
	Declare Virtual Function push(ByRef item As E P) As E P
	'Declare Virtual Function search(ByRef o As mdObject) As Integer
	Declare Virtual Function search(ByRef o As E P) As Integer
	
	Declare Virtual Operator Cast() As Integer
	Declare Virtual Operator Cast() As String
	Declare Virtual Operator Let(ByRef c As mdCollection##E##P)
	
#If __FB_MIN_VERSION__(0, 91, 0)
	Declare Virtual Operator [](ByVal index As Integer) ByRef As E P
#EndIf
End Type

MODULE_SCOPE Constructor mdStack##E##P()
	
End Constructor

MODULE_SCOPE Constructor mdStack##E##P(ByRef element As E P)
	This.add(element)
End Constructor

MODULE_SCOPE Constructor mdStack##E##P(ByRef l As mdCollection##E##P)
	This.addAll(l)
End Constructor

MODULE_SCOPE Function mdStack##E##P.empty() As Boolean
	Return This.isEmpty()
End Function

MODULE_SCOPE Function mdStack##E##P.getClass() As String
	Return UCase("mdStack(" & #E & IIf(Len(#P), ", " & #P, "") & ")")
End Function

MODULE_SCOPE Function mdStack##E##P.peek_() As E P
	Return This.get(0)
End Function

MODULE_SCOPE Function mdStack##E##P.pop() As E P
	Return This.remove(0)
End Function

MODULE_SCOPE Function mdStack##E##P.push(ByRef item As E P) As E P
	This.add(0, item)
	Return item
End Function

'MODULE_SCOPE Function mdStack##E##P.search(ByRef o As mdObject) As Integer
'	
'End Function

MODULE_SCOPE Function mdStack##E##P.search(ByRef o As E P) As Integer
	Return This.indexOf(o) + 1
End Function

MODULE_SCOPE Operator mdStack##E##P.Cast() As Integer
	Return This.hashCode()
End Operator

MODULE_SCOPE Operator mdStack##E##P.Cast() As String
	Return This.toString()
End Operator

MODULE_SCOPE Operator mdStack##E##P.Let(ByRef c As mdCollection##E##P)
	This.clear()
	This.addAll(c)
End Operator

#If __FB_MIN_VERSION__(0, 91, 0)
MODULE_SCOPE Operator mdStack##E##P.[](ByVal index As Integer) ByRef As E P
	Dim As Integer i = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		If i = index Then
			Return currentNode->value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As mdBasicNode##E##P Ptr tempRet
	Return tempRet->value
End Operator
#EndIf

MODULE_SCOPE Operator = (ByRef lhs As mdStack##E##P, ByRef rhs As mdStack##E##P) As Boolean
	Return lhs.toString() = rhs.toString()
End Operator

#EndIf '__MDSTACK_BI__

#EndMacro

#Define mdStackDeclare(E, P...) mdStackDeclarePtr(E, P)
