'mdVector - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/Vector.html


#Include Once "md/util/mdList.bi"

#Define mdVectorPtr(E, P) mdVector##E##P
#Define mdVector(E, P...) mdVectorPtr(E, P)

#Macro mdVectorDeclarePtr(E, P)

mdListDeclarePtr(E, P)

#Ifndef mdVector##E##P
'#Define __MDVECTOR_BI__

Type mdVector##E##P Extends mdList##E##P
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef element As E P)
	Declare Constructor (ByRef l As mdCollection##E##P)
	
	Declare Virtual Function add(ByRef element As E P) As Boolean
	Declare Virtual Function add(ByVal index As Integer, ByRef element As E P) As Boolean
	Declare Virtual Sub addElement(ByRef element As E P)
	Declare Virtual Function capacity() As Integer
	'Declare Virtual Function clone() As mdObject
	'Declare Virtual Function clone() As mdVector##E##P Ptr
	Declare Virtual Sub copyInto(anArray() As E P)
	Declare Virtual Function elementAt(ByVal index As Integer) As E P
	'Declare Virtual Function elements() As mdEnumeration##E##P
	Declare Virtual Sub ensureCapacity(ByVal minCapacity As Integer)
	Declare Virtual Function firstElement() As E P
	Declare Virtual Function getClass() As String
	'Declare Virtual Function indexOf(ByRef o As mdObject) As Integer
	Declare Virtual Function indexOf(ByRef o As E P) As Integer
	Declare Virtual Function indexOf(ByRef o As E P, ByVal index As Integer) As Integer
	Declare Virtual Sub insertElementAt(ByRef o As E P, ByVal index As Integer)
	Declare Virtual Function lastElement() As E P
	'Declare Virtual Function lastIndexOf(ByRef o As mdObject) As Integer
	Declare Virtual Function lastIndexOf(ByRef o As E P) As Integer
	Declare Virtual Function lastIndexOf(ByRef o As E P, ByVal index As Integer) As Integer
	Declare Virtual Sub removeAllElements()
	Declare Virtual Function removeElement(ByRef obj As E P) As Boolean
	Declare Virtual Sub removeElementAt(ByVal index As Integer)
	Declare Virtual Sub setElementAt(ByRef element As E P, ByVal index As Integer)
	Declare Virtual Sub setSize(ByVal newSize As Integer)
	Declare Virtual Sub trimToSize()
	
	Declare Virtual Operator Cast() As Integer
	Declare Virtual Operator Cast() As String
	Declare Virtual Operator Let(ByRef c As mdCollection##E##P)
	
#If __FB_MIN_VERSION__(0, 91, 0)
	Declare Virtual Operator [](ByVal index As Integer) ByRef As E P
#EndIf
	
	'Protected:
	Declare Virtual Sub removeRange(ByVal fromIndex As Integer, ByVal toIndex As Integer)
	
	Protected:
	capacity_ As Integer = 10
	increment As Integer = 0
End Type

MODULE_SCOPE Constructor mdVector##E##P()
	
End Constructor

MODULE_SCOPE Constructor mdVector##E##P(ByRef element As E P)
	This.add(element)
End Constructor

MODULE_SCOPE Constructor mdVector##E##P(ByRef l As mdCollection##E##P)
	This.capacity_ = l.size()
	This.addAll(l)
End Constructor

MODULE_SCOPE Function mdVector##E##P.add(ByRef element As E P) As Boolean
	If This.size() >= This.capacity_ Then
		Return FALSE
	EndIf
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, prevNode
	While currentNode <> NULL
		prevNode = currentNode
		currentNode = currentNode->nex
	Wend
	
	currentNode = New mdBasicNode##E##P
	If currentNode = NULL Then
		Return FALSE
	Else
		currentNode->value = element
		If prevNode <> NULL Then
			prevNode->nex = currentNode
		EndIf
		If This.node = NULL Then
			This.node = currentNode
		EndIf
		Return TRUE
	EndIf
End Function

MODULE_SCOPE Function mdVector##E##P.add(ByVal index As Integer, ByRef element As E P) As Boolean
	If This.size() >= This.capacity_ Then
		Return FALSE
	EndIf
	Dim As Integer i = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, nextNode, prevNode, newNode
	While currentNode <> NULL
		If i = index Then
			nextNode = currentNode
			newNode = New mdBasicNode##E##P
			If newNode = NULL Then
				Return FALSE
			Else
				newNode->value = element
				newNode->nex = currentNode
				If prevNode <> NULL Then
					prevNode->nex = newNode
				EndIf
				If This.node = currentNode Then
					This.node = newNode
				EndIf
				Return TRUE
			EndIf
		EndIf
		
		i += 1
		prevNode = currentNode
		currentNode = currentNode->nex
	Wend
	
	Return FALSE
End Function

MODULE_SCOPE Sub mdVector##E##P.addElement(ByRef element As E P)
	This.add(element)
End Sub

MODULE_SCOPE Function mdVector##E##P.capacity() As Integer
	Return This.capacity_
End Function

'MODULE_SCOPE Function mdVector##E##P.clone() As mdVector##E##P Ptr
'	Dim As mdVector##E##P Ptr retVector = New mdVector##E##P
'	For i As Integer = 0 To This.size() - 1
'		retVector->add(This.get(i))
'	Next
'	Return retVector
'End Function

MODULE_SCOPE Sub mdVector##E##P.copyInto(anArray() As E P)
	This.toArray(anArray())
End Sub

MODULE_SCOPE Function mdVector##E##P.elementAt(ByVal index As Integer) As E P
	Return This.get(index)
End Function

MODULE_SCOPE Sub mdVector##E##P.ensureCapacity(ByVal minCapacity As Integer)
	If This.capacity_ < minCapacity Then
		This.capacity_ = minCapacity
	EndIf
End Sub

MODULE_SCOPE Function mdVector##E##P.firstElement() As E P
	Return This.get(0)
End Function

MODULE_SCOPE Function mdVector##E##P.getClass() As String
	Return UCase("mdVector(" & #E & IIf(Len(#P), ", " & #P, "") & ")")
End Function

MODULE_SCOPE Function mdVector##E##P.indexOf(ByRef o As E P) As Integer
	Dim As Integer i = -1, retIndex = -1
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		i += 1
		If currentNode->value = o Then
			retIndex = i
			Exit While
		EndIf
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

MODULE_SCOPE Function mdVector##E##P.indexOf(ByRef o As E P, ByVal index As Integer) As Integer
	Dim As Integer i = -1, retIndex = -1
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		i += 1
		If i >= index AndAlso currentNode->value = o Then
			retIndex = i
			Exit While
		EndIf
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

MODULE_SCOPE Sub mdVector##E##P.insertElementAt(ByRef o As E P, ByVal index As Integer)
	This.add(index, o)
End Sub

MODULE_SCOPE Function mdVector##E##P.lastElement() As E P
	Return This.get(This.size() - 1)
End Function

MODULE_SCOPE Function mdVector##E##P.lastIndexOf(ByRef o As E P) As Integer
	Dim As Integer i = 0, retIndex = -1
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		If currentNode->value = o Then
			retIndex = i
		EndIf
		i += 1
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

MODULE_SCOPE Function mdVector##E##P.lastIndexOf(ByRef o As E P, ByVal index As Integer) As Integer
	Dim As Integer i = -1, retIndex = -1
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		If i < index AndAlso currentNode->value = o Then
			retIndex = i + 1
		EndIf
		i += 1
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

MODULE_SCOPE Sub mdVector##E##P.removeAllElements()
	This.clear()
End Sub

MODULE_SCOPE Function mdVector##E##P.removeElement(ByRef obj As E P) As Boolean
	Return This.remove(obj)
End Function

MODULE_SCOPE Sub mdVector##E##P.removeElementAt(ByVal index As Integer)
	Dim As E P tempE = This.remove(index)
End Sub

MODULE_SCOPE Sub mdVector##E##P.setElementAt(ByRef element As E P, ByVal index As Integer)
	Dim As E P tempE = This.set(index, element)
End Sub

MODULE_SCOPE Sub mdVector##E##P.setSize(ByVal newSize As Integer)
	If This.size() < newSize Then
		For i As Integer = 0 To (newSize - This.size()) - 1
			Dim As E P emptyElement
			This.add(emptyElement)
		Next
	ElseIf This.size() > newSize Then
		This.removeRange(newSize, This.size())
	EndIf
End Sub

MODULE_SCOPE Sub mdVector##E##P.trimToSize()
	This.capacity_ = This.size()
End Sub

MODULE_SCOPE Operator mdVector##E##P.Cast() As Integer
	Return This.hashCode()
End Operator

MODULE_SCOPE Operator mdVector##E##P.Cast() As String
	Return This.toString()
End Operator

MODULE_SCOPE Operator mdVector##E##P.Let(ByRef c As mdCollection##E##P)
	This.clear()
	This.addAll(c)
End Operator

#If __FB_MIN_VERSION__(0, 91, 0)
MODULE_SCOPE Operator mdVector##E##P.[](ByVal index As Integer) ByRef As E P
	Dim As Integer i = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	While currentNode <> NULL
		If i = index Then
			Return currentNode->value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As mdBasicNode##E##P Ptr tempRet
	Return tempRet->value
End Operator
#EndIf

MODULE_SCOPE Sub mdVector##E##P.removeRange(ByVal fromIndex As Integer, ByVal toIndex As Integer)
	Dim As E P tempE
	For i As Integer = toIndex - 1 To fromIndex Step -1
		tempE = This.remove(i)
	Next
End Sub

MODULE_SCOPE Operator = (ByRef lhs As mdVector##E##P, ByRef rhs As mdVector##E##P) As Boolean
	Return lhs.toString() = rhs.toString()
End Operator

#EndIf '__MDVECTOR_BI__

#EndMacro

#Define mdVectorDeclare(E, P...) mdVectorDeclarePtr(E, P)
