#Include Once "dir.bi"

#Ifndef FALSE
	#Define FALSE 0
	#Define TRUE (Not FALSE)
#EndIf
#If Defined(__FB_WIN32__)
	#Define NEWLINE !"\r\n"
	#Define SEPARATOR "\"
#ElseIf Defined(__FB_LINUX__)
	#Define NEWLINE !"\n"
	#Define SEPARATOR "/"
#EndIf

Type Compiler
	Declare Constructor (fbc As String, compileOptions As String, activated As Integer)
	
	As String fbc
	As String compileOptions
	As Integer activated
End Type
Constructor Compiler(fbc As String, compileOptions As String, activated As Integer)
	This.fbc = fbc
	This.compileOptions = compileOptions
	This.activated = activated
End Constructor

Declare Sub compileDirectory(fbc As String, compileOptions As String, startDir As String, attribute As Integer, runAfterCompilation As Integer = FALSE, deleteExeAfterwards As Integer = FALSE)

Declare Sub systemOut(s As String)


'#####################################################
' Configure here
'#####################################################
Dim As String compileOptions = "-g -exx -w pedantic"
Dim As Compiler fbc(0 To ...) = { Type<Compiler>("fbc", compileOptions, TRUE), _ 'default fbc
								  Type<Compiler>("""C:\Program Files (x86)\FreeBASIC\0.91_x86\fbc.exe""", compileOptions, TRUE), _ 'current x86 build
								  Type<Compiler>("""C:\Program Files (x86)\FreeBASIC\0.91_x64\fbc.exe""", compileOptions, TRUE) }  'current x64 build
Dim As String  startDir      = "TestCases" & SEPARATOR
Dim As Integer attribute     = fbDirectory Or fbNormal
Dim As Integer runExe        = TRUE
Dim As Integer deleteExe     = TRUE
'#####################################################


'Output
systemOut "-------------------------------------------------------------------------------"
systemOut "| Starting...                                                                 |"
systemOut "-------------------------------------------------------------------------------"
For i As Integer = 0 To UBound(fbc)
	If fbc(i).activated Then
		systemOut "Using compiler: " & fbc(i).fbc
		systemOut String(Len(fbc(i).fbc) + Len("Using compiler: "), "-")
		systemOut "-------------------------------------------------------------------------------"
		compileDirectory(fbc(i).fbc, fbc(i).compileOptions, startDir, attribute, runExe, deleteExe)
		systemOut "-------------------------------------------------------------------------------"
	EndIf
Next
systemOut "-------------------------------------------------------------------------------"
systemOut "| Finished!                                                                   |"
systemOut "-------------------------------------------------------------------------------"

While Len(InKey) : Wend
Print "Press any key..."
Sleep

Sub compileDirectory(fbc As String, compileOptions As String, startDir As String, attribute As Integer, runAfterCompilation As Integer = FALSE, deleteExeAfterwards As Integer = FALSE)
	Dim As String currName, temp
	Dim As Integer lines, FF, attributeRet
	
	'Dim As String currentDirectory = CurDir()
	
	currName = Dir(startDir & "*", attribute, @attributeRet)
	
	While currName <> ""
		Select Case attributeRet
			Case fbDirectory
				If currName <> "." AndAlso currName <> ".." Then
					compileDirectory(fbc, compileOptions, startDir & currName & SEPARATOR, attribute, runAfterCompilation, deleteExeAfterwards)
					'reset dir - may cost time in huge folders but will do the trick in most cases
					Dim As String tempName = Dir(startDir & "*", attribute, @attributeRet)
					While tempName <> currName
						tempName = Dir("", attribute, @attributeRet)
					Wend
				EndIf
			Case Else
				Dim As String fileNameWithoutExtension = Left(currName, Len(currName) - 4)
				Dim As String fileExtension = Mid(currName, InStrRev(currName, "."))
				Dim As String fileNameExe
				#If Defined(__FB_LINUX__)
					fileNameExe = fileNameWithoutExtension
				#ElseIf Defined(__FB_WIN32__)
					fileNameExe = fileNameWithoutExtension & ".exe"
				#EndIf
				If Left(currName, 5) = "Test_" AndAlso fileExtension = ".bas" Then
					systemOut "Compiling " & startDir & currName & "..."
					Dim As String temp, fbcMessages
					lines = 0
					FF = FreeFile
					Open Pipe fbc & " " & compileOptions & " " & startDir & currName & " 2>&1" For Input As #FF
						While Not Eof( FF )
							Line Input #FF, temp
							fbcMessages &= temp
						Wend
						If Len(fbcMessages) Then
							systemOut "Compilation failed:"
							systemOut fbcMessages
							systemOut ""
						EndIf
					Close #FF
					
					If runAfterCompilation AndAlso Len(fbcMessages) = 0 Then
						systemOut "Running " & fileNameExe & ":"
						systemOut String(Len(fileNameExe) + Len("Running ") + 1, "-")
						
						Dim As String temp2
						Dim As Integer FFF = FreeFile
						Open Pipe startDir & fileNameExe & " 2>&1" For Input As #FFF
							While Not Eof(FFF)
								Line Input #FFF, temp2
								systemOut temp2
							Wend
						Close #FF
						systemOut String(Len(fileNameExe) + Len("Running ") + 1, "-")
					EndIf
					
					If deleteExeAfterwards AndAlso Len(fbcMessages) = 0 Then
						systemOut "Deleting " & fileNameExe & "..."
						Sleep 100
						Select Case Kill(startDir & fileNameExe)
							Case 1
								systemOut "Deleting failed: file does not exist: " & startDir & fileNameExe
							Case 2
								systemOut "Deleting failed: " & startDir & fileNameExe
						End Select
					EndIf
					
					systemOut "-------------------------------------------------------------------------------"
				EndIf
		End Select
		
		currName = Dir("", attribute, @attributeRet)
	Wend
End Sub

Sub systemOut(s As String)
	Print s
	Dim As Integer FF = FreeFile
	Open "Test-Log.txt" For Append As #FF
		Print #FF, s
	Close #FF
End Sub
