#Include Once "md/helper/mdCollectionsHelper.bi"

Sub stringToList()
	Dim As mdList(String) list
	list.add("User1")
	list.add("User2")
	list.add("User3")
	
	Dim As mdList(String) list2 = mdCollectionsHelper.createList(list)
	Dim As String element
	For i As Integer = 0 To list2.size() - 1
		element = list2.get(i)
		Assert(element = "User" & (i + 1))
	Next
End Sub

Sub stringToMap()
	Dim As String temp
	Dim As mdMap(String, String) map
	temp = map.put("User1", "1")
	temp = map.put("User2", "2")
	temp = map.put("User3", "3")
	
	Dim As mdMap(String, String) map2 = mdCollectionsHelper.createMap(map)
	Dim As String element
	For i As Integer = 0 To map2.size() - 1
		element = map2.get("User" & (i + 1))
		Assert(element = Str(i + 1))
	Next
End Sub

Sub complex1()
	Dim As String mapWithLists = "{items1=[1, 2, 3, 4], items2=[12, 23, 34, 45]}"
	
	Dim As mdMap(String, String) map = mdCollectionsHelper.createMap(mapWithLists)
	Assert(map.get("items1") = "[1, 2, 3, 4]")
	Assert(map.get("items2") = "[12, 23, 34, 45]")
	
	Dim As mdList(String) list1 = mdCollectionsHelper.createList(map.get("items1"))
	Dim As mdList(String) list2 = mdCollectionsHelper.createList(map.get("items2"))
	
	For i As Integer = 0 To list1.size() - 1
		Assert(list1.get(i) = Str(i + 1))
	Next
	Assert(list2.get(0) = Str(12))
	Assert(list2.get(1) = Str(23))
	Assert(list2.get(2) = Str(34))
	Assert(list2.get(3) = Str(45))
End Sub

Sub complex2()
	Dim As String listWithMaps = "[{value=1}, {value=2}, {value=3}, {value=4}]"
	
	Dim As mdList(String) list = mdCollectionsHelper.createList(listWithMaps)
	For i As Integer = 0 To list.size() - 1
		Assert(list.get(i) = "{value=" + Str(i + 1) + "}")
		
		Dim As mdMap(String, String) tempMap = mdCollectionsHelper.createMap(list.get(i))
		Assert(tempMap.get("value") = Str(i + 1))
	Next
End Sub

Sub complex3()
	Dim As String mapWithListsWithMaps = "{items1=[{value=1}, {value=2}, {value=3}, {value=4}], items2=[{value=12}, {value=23}, {value=34}, {value=45}]}"
	
	Dim As mdMap(String, String) map = mdCollectionsHelper.createMap(mapWithListsWithMaps)
	Assert(map.get("items1") = "[{value=1}, {value=2}, {value=3}, {value=4}]")
	Assert(map.get("items2") = "[{value=12}, {value=23}, {value=34}, {value=45}]")
	
	Dim As mdList(String) list1 = mdCollectionsHelper.createList(map.get("items1"))
	Dim As mdList(String) list2 = mdCollectionsHelper.createList(map.get("items2"))
	
	For i As Integer = 0 To list1.size() - 1
		Assert(list1.get(i) = "{value=" + Str(i + 1) + "}")
		
		Dim As mdMap(String, String) innerMap = mdCollectionsHelper.createMap(list1.get(i))
		Assert(innerMap.get("value") = Str(i + 1))
	Next
	Assert(list2.get(0) = "{value=12}")
	Assert(list2.get(1) = "{value=23}")
	Assert(list2.get(2) = "{value=34}")
	Assert(list2.get(3) = "{value=45}")
	For i As Integer = 0 To list2.size() - 1
		Dim As mdMap(String, String) innerMap = mdCollectionsHelper.createMap(list2.get(i))
		Select Case i
			Case 0
				Assert(innerMap.get("value") = "12")
			Case 1
				Assert(innerMap.get("value") = "23")
			Case 2
				Assert(innerMap.get("value") = "34")
			Case 3
				Assert(innerMap.get("value") = "45")
		End Select
	Next
End Sub

Sub complex4()
	Dim As String listWithMapsLists = "[{values=[1, 2, 3]}, {values=[12, 23, 34]}]"
	
	Dim As mdList(String) list = mdCollectionsHelper.createList(listWithMapsLists)
	Assert(list.get(0) = "{values=[1, 2, 3]}")
	Assert(list.get(1) = "{values=[12, 23, 34]}")
	
	For i As Integer = 0 To list.size() - 1
		Dim As mdMap(String, String) tempMap = mdCollectionsHelper.createMap(list.get(i))
		Select Case i
			Case 0
				Assert(tempMap.get("values") = "[1, 2, 3]")
				
				Dim As mdList(String) innerList = mdCollectionsHelper.createList(tempMap.get("values"))
				For j As Integer = 0 To innerList.size() - 1
					Assert(innerList.get(j) = Str(j + 1))
				Next
			Case 1
				Assert(tempMap.get("values") = "[12, 23, 34]")
				
				Dim As mdList(String) innerList = mdCollectionsHelper.createList(tempMap.get("values"))
				Assert(innerList.get(0) = "12")
				Assert(innerList.get(1) = "23")
				Assert(innerList.get(2) = "34")
		End Select
	Next
End Sub

stringToList()
stringToMap()
complex1()
complex2()
complex3()
complex4()
