#Include Once "md/util/mdCollection.bi"

mdCollectionDeclare(String)


Sub constructor_empty()
	Dim As mdCollection(String) s_c
	Assert(s_c.toString() = "[]")
End Sub
Sub constructor_element()
	Dim As mdCollection(String) s_c = "Test"
	Dim As String s_c_array()
	s_c.toArray(s_c_array())
	Assert(s_c.toString() = "[Test]")
	Assert(s_c_array(0) = "Test")
End Sub
Sub constructor_collection()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("2")
	s_c.add("4")
	
	Dim As mdCollection(String) s_c2 = s_c
	Assert(s_c.size() = s_c2.size())
	Assert(s_c.toString() = s_c2.toString())
End Sub
Sub destructor_empty()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	Assert(s_c.size() = 1)
	s_c.Destructor()
	Assert(s_c.size() = 0)
End Sub

Sub add()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 3, 4, 5]")
End Sub
Sub addAll()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("1")
	s_c.add("2")
	
	Dim As mdCollection(String) s_c2
	s_c2.addAll(s_c)
	Assert(s_c.size() = s_c2.size())
	Assert(s_c.toString() = s_c2.toString())
End Sub
Sub clear_()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("1")
	s_c.add("2")
	Assert(s_c.size() = 4)
	s_c.clear()
	Assert(s_c.size() = 0)
End Sub
Sub contains_object()
	Print "contains_object not implemented!!!"
End Sub
Sub contains_element()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("1")
	s_c.add("2")
	Assert(s_c.contains("2"))
End Sub
Sub containsAll()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("1")
	s_c.add("2")
	Dim As mdCollection(String) s_c2
	s_c2.add("0")
	s_c2.add("1")
	Assert(s_c2.containsAll(s_c) = FALSE)
	s_c2.add("2")
	Assert(s_c2.containsAll(s_c))
End Sub
Sub equals_object()
	Print "equals_object not implemented!!!"
End Sub
Sub equals_collection()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	Dim As mdCollection(String) s_c2
	s_c2.add("0")
	s_c2.add("1")
	Assert(s_c.equals(s_c2) = TRUE)
End Sub
Sub getClass()
	Dim As mdCollection(String) s_c
	Assert(s_c.getClass() = UCase("mdCollection(String)"))
End Sub
Sub hashCode()
	Print "hashCode not implemented!!!"
End Sub
Sub isEmpty()
	Dim As mdCollection(String) s_c
	Assert(s_c.isEmpty() = TRUE)
	s_c.add("0")
	Assert(s_c.isEmpty() = FALSE)
End Sub
Sub iterator()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	Dim As mdIterator(String) s_c_iter = s_c.iterator()
	Dim As Long i = 0
	Assert(s_c_iter.hasNext() = TRUE)
	While s_c_iter.hasNext()
		Dim As String element = s_c_iter.nex()
		Assert(element = Str(i))
		i += 1
	Wend
End Sub
Sub remove_index()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("2")
	s_c.add("1")
	Dim As String s_temp = s_c.remove(1)
	Assert(s_c.toString() = "[0, 1]")
	s_temp = s_c.remove(0)
	Assert(s_c.toString() = "[1]")
	s_temp = s_c.remove(0)
	Assert(s_c.toString() = "[]")
End Sub
Sub remove_object()
	Print "remove_object not implemented!!!"
End Sub
Sub remove_element()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("2")
	s_c.add("1")
	s_c.remove("2")
	Assert(s_c.toString() = "[0, 1]")
	s_c.remove("0")
	Assert(s_c.toString() = "[1]")
	s_c.remove("1")
	Assert(s_c.toString() = "[]")
End Sub
Sub removeAll()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdCollection(String) s_c2
	s_c2.add("1")
	s_c2.add("2")
	s_c.removeAll(s_c2)
	Assert(s_c.toString() = "[0, 3, 4, 5]")
End Sub
Sub retainAll()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdCollection(String) s_c2
	s_c2.add("1")
	s_c2.add("2")
	s_c.retainAll(s_c2)
	Assert(s_c.toString() = "[1, 2]")
End Sub
'Sub share()
'	Dim As mdCollection(String) s_c
'	s_c.add("0")
'	s_c.add("1")
'	s_c.add("2")
'	s_c.add("3")
'	Dim As mdCollection(String) s_c2
'	s_c2.share(s_c)
'	Assert(s_c.toString() = s_c2.toString())
'	Assert(s_c.equals(s_c2) = TRUE)
'End Sub
Sub size()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("2")
	s_c.add("1")
	Assert(s_c.size() = 3)
	s_c.remove("2")
	Assert(s_c.size() = 2)
End Sub
Sub toArray()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	Dim As String s_c_array()
	s_c.toArray(s_c_array())
	Assert(s_c.size() = 3)
	For i As Long = 0 To UBound(s_c_array)
		Assert(s_c_array(i) = Str(i))
	Next
End Sub
Sub toString()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	Assert(s_c.toString() = "[0, 1, 2]")
End Sub

Sub Operator_Cast_Integer()
	Dim As mdCollection(String) s_c
	Dim As Integer s_c_hashcode = s_c
	Assert(s_c_hashcode <> 0)
	Assert(s_c_hashcode = s_c.hashCode())
End Sub
Sub Operator_Cast_String()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	Dim As String s_c_string = s_c
	Assert(s_c_string = s_c.toString())
End Sub
Sub Operator_Let()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	Dim As mdCollection(String) s_c2
	s_c2.add("2")
	Assert(s_c.toString() = "[0, 1]")
	Assert(s_c2.toString() = "[2]")
	s_c2 = s_c
	Assert(s_c2.toString() = "[0, 1]")
End Sub
Sub Operator_equals()
	Dim As mdCollection(String) s_c
	s_c.add("0")
	s_c.add("1")
	Dim As mdCollection(String) s_c2
	s_c2.add("0")
	Assert(s_c.toString() <> s_c2.toString())
	s_c2.add("1")
	Assert(s_c.toString() = s_c2.toString())
End Sub



constructor_empty()
constructor_element()
constructor_collection()
destructor_empty()

add()
addAll()
clear_()
'clone()
'contains_object()
contains_element()
containsAll()
'equals_object()
equals_collection()
getClass()
'hashCode()
isEmpty()
iterator()
remove_index()
'remove_object()
remove_element()
removeAll()
retainAll()
'share()
size()
toArray()
toString()

Operator_Cast_Integer()
Operator_Cast_String()
Operator_Let()
Operator_equals()

