#Include Once "md/util/mdList.bi"

mdListDeclare(Long)


Sub constructor_empty()
	Dim As mdList(Long) l_c
	Assert(l_c.toString() = "[]")
End Sub
Sub constructor_element()
	Dim As mdList(Long) l_c = 45462452
	Dim As Long l_c_array()
	l_c.toArray(l_c_array())
	Assert(l_c.toString() = "[45462452]")
	Assert(l_c_array(0) = 45462452)
	Assert(l_c_array(0) = 45462452)
End Sub
Sub constructor_collection()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(2)
	l_c.add(4)
	
	Dim As mdList(Long) l_c2 = l_c
	Assert(l_c.size() = l_c2.size())
	Assert(l_c.toString() = l_c2.toString())
End Sub
Sub destructor_empty()
	Dim As mdList(Long) l_c
	l_c.add(0)
	Assert(l_c.size() = 1)
	l_c.Destructor()
	Assert(l_c.size() = 0)
End Sub

Sub add_element()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 3, 4, 5]")
End Sub
Sub add_element_by_index()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(0, 3)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	l_c.add(4, 6)
	Assert(l_c.toString() = "[3, 0, 1, 2, 6, 3, 4, 5]")
End Sub
Sub addAll_collection()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	
	Dim As mdList(Long) l_c2
	l_c2.addAll(l_c)
	Assert(l_c.size() = l_c2.size())
	Assert(l_c.toString() = l_c2.toString())
End Sub
Sub addAll_collection_by_index()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	
	Dim As mdList(Long) l_c2
	l_c2.addAll(l_c)
	
	l_c.addAll(2, l_c2)
	Assert(l_c.toString() = "[0, 1, 0, 1, 1, 2, 1, 2]")
	
	Dim As mdList(Long) l_c3
	l_c3.addAll(l_c2)
	
	l_c3.addAll(0, l_c2)
	Assert(l_c3.toString() = "[0, 1, 1, 2, 0, 1, 1, 2]")
End Sub
Sub clear_()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	Assert(l_c.size() = 4)
	l_c.clear()
	Assert(l_c.size() = 0)
End Sub
Sub clone()
	Print "clone not implemented!!!"
End Sub
Sub contains_object()
	Print "contains_object not implemented!!!"
End Sub
Sub contains_element()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	Assert(l_c.contains(2))
End Sub
Sub containsAll()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	Dim As mdList(Long) l_c2
	l_c2.add(0)
	l_c2.add(1)
	Assert(l_c2.containsAll(l_c) = FALSE)
	l_c2.add(2)
	Assert(l_c2.containsAll(l_c))
End Sub
Sub equals_object()
	Print "equals_object not implemented!!!"
End Sub
Sub equals_collection()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Dim As mdList(Long) l_c2
	l_c2.add(0)
	l_c2.add(1)
	Assert(l_c.equals(l_c2) = TRUE)
End Sub
Sub get_()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	
	For i As Long = 0 To l_c.size() - 1
		Assert(i = l_c.get(i))
	Next
End Sub
Sub getClass()
	Dim As mdList(Long) l_c
	Assert(l_c.getClass() = UCase("mdList(Long)"))
End Sub
Sub hashCode()
	Print "hashCode not implemented!!!"
End Sub
Sub isEmpty()
	Dim As mdList(Long) l_c
	Assert(l_c.isEmpty() = TRUE)
	l_c.add(0)
	Assert(l_c.isEmpty() = FALSE)
End Sub
Sub indexOf_object()
	Print "indexOf_object not implemented!!!"
End Sub
Sub indexOf_element()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	For i As Long = 0 To l_c.size() - 1
		Assert(l_c.indexOf(i) = i)
	Next
End Sub
Sub iterator()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Dim As mdIterator(Long) l_c_iter = l_c.iterator()
	Dim As Long j = 0
	Assert(l_c_iter.hasNext() = TRUE)
	While l_c_iter.hasNext()
		Dim As Long element = l_c_iter.nex()
		Assert(element = j)
		j += 1
	Wend
End Sub
Sub lastIndexOf_object()
	Print "lastIndexOf_object not implemented!!!"
End Sub
Sub lastIndexOf_element()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	For i As Long = 0 To l_c.size() - 1
		Assert(l_c.lastIndexOf(i) = i)
	Next
End Sub
Sub listIterator()
	Print "listIterator not implemented!!!"
End Sub
Sub listIterator_index()
	Print "listIterator_index not implemented!!!"
End Sub
Sub remove_index()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	l_c.remove(1)
	Assert(l_c.toString() = "[0, 1]")
	l_c.remove(0)
	Assert(l_c.toString() = "[1]")
	l_c.remove(0)
	Assert(l_c.toString() = "[]")
End Sub
Sub remove_object()
	Print "remove_object not implemented!!!"
End Sub
Sub remove_element()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	l_c.remove(CLng(2))
	Assert(l_c.toString() = "[0, 1]")
	l_c.remove(CLng(0))
	Assert(l_c.toString() = "[1]")
	l_c.remove(CLng(1))
	Assert(l_c.toString() = "[]")
End Sub
Sub removeAll()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdList(Long) l_c2
	l_c2.add(1)
	l_c2.add(2)
	l_c.removeAll(l_c2)
	Assert(l_c.toString() = "[0, 3, 4, 5]")
End Sub
Sub retainAll()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdList(Long) l_c2
	l_c2.add(1)
	l_c2.add(2)
	l_c.retainAll(l_c2)
	Assert(l_c.toString() = "[1, 2]")
End Sub
Sub set()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Assert(l_c.set(3, 6) = 3)
	Assert(l_c.toString() = "[0, 1, 2, 6, 4, 5]")
End Sub
'Sub share()
'	Dim As mdList(Long) l_c
'	l_c.add(0)
'	l_c.add(1)
'	l_c.add(2)
'	l_c.add(3)
'	Dim As mdList(Long) l_c2
'	l_c2.share(l_c)
'	Assert(l_c.toString() = l_c2.toString())
'	Assert(l_c.equals(l_c2) = TRUE)
'End Sub
Sub size()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	Assert(l_c.size() = 3)
	l_c.remove(CLng(2))
	Assert(l_c.size() = 2)
End Sub
Sub subList()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Assert(l_c.subList(1, 4).toString() = "[1, 2, 3, 4]")
End Sub
Sub toArray()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Dim As Long l_c_array()
	l_c.toArray(l_c_array())
	Assert(l_c.size() = 3)
	For j As Long = 0 To UBound(l_c_array)
		Assert(l_c_array(j) = j)
	Next
End Sub
Sub toString()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Assert(l_c.toString() = "[0, 1, 2]")
End Sub

Sub Operator_Cast_Integer()
	Dim As mdList(Long) l_c
	Dim As Integer l_c_hashcode = l_c
	Assert(l_c_hashcode <> 0)
	Assert(l_c_hashcode = l_c.hashCode())
End Sub
Sub Operator_Cast_String()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Dim As String l_c_string = l_c
	Assert(l_c_string = l_c.toString())
End Sub
Sub Operator_Let()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Dim As mdList(Long) l_c2
	l_c2.add(2)
	Assert(l_c.toString() = "[0, 1]")
	Assert(l_c2.toString() = "[2]")
	l_c2 = l_c
	Assert(l_c2.toString() = "[0, 1]")
End Sub
Sub Operator_equals()
	Dim As mdList(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Dim As mdList(Long) l_c2
	l_c2.add(0)
	Assert(l_c.toString() <> l_c2.toString())
	l_c2.add(1)
	Assert(l_c.toString() = l_c2.toString())
End Sub



constructor_empty()
constructor_element()
constructor_collection()
destructor_empty()

add_element()
add_element_by_index()
addAll_collection()
addAll_collection_by_index()
clear_()
'clone()
'contains_object()
contains_element()
containsAll()
'equals_object()
equals_collection()
get_()
getClass()
'hashCode()
'indexOf_object()
indexOf_element()
isEmpty()
iterator()
'lastIndexOf_object()
lastIndexOf_element()
'listIterator()
'listIterator_index()
remove_index()
'remove_object()
remove_element()
removeAll()
retainAll()
set()
'share()
size()
subList()
toArray()
toString()

Operator_Cast_Integer()
Operator_Cast_String()
Operator_Let()
Operator_equals()

