#Include Once "md/util/mdList.bi"

Type MyClass
	Declare Constructor ()
	Declare Constructor (ByVal value As Integer)
	Declare Operator Cast() As String
	As Integer myVar
End Type
'must have a default constructor or no explicit constructor at all!
Constructor MyClass()
	
End Constructor
'this is constructor optional
Constructor MyClass(ByVal value As Integer)
	myVar = value
End Constructor
'must implement cast to string for string representation
Operator MyClass.Cast() As String
	Return Str(myVar)
End Operator
'operator for comparision must exist!
Operator = (ByRef lhs As MyClass, ByRef rhs As MyClass) As Integer
	Return lhs.myVar = rhs.myVar
End Operator

mdListDeclare(MyClass)


Sub constructor_empty()
	Dim As mdList(MyClass) mc_c
	Assert(mc_c.toString() = "[]")
End Sub
Sub constructor_element()
	Dim As mdList(MyClass) mc_c = MyClass(1234)
	Dim As MyClass mc_c_array()
	mc_c.toArray(mc_c_array())
	Assert(mc_c.toString() = "[1234]")
	Assert(mc_c_array(0) = MyClass(1234))
End Sub
Sub constructor_collection()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	mc_c.add(MyClass(3))
	mc_c.add(MyClass(4))
	mc_c.add(MyClass(2))
	mc_c.add(MyClass(4))
	
	Dim As mdList(MyClass) mc_c2 = mc_c
	Assert(mc_c.size() = mc_c2.size())
	Assert(mc_c.toString() = mc_c2.toString())
End Sub
Sub destructor_empty()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	Assert(mc_c.size() = 1)
	mc_c.Destructor()
	Assert(mc_c.size() = 0)
End Sub

Sub add_element()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	mc_c.add(MyClass(3))
	mc_c.add(MyClass(3))
	mc_c.add(MyClass(4))
	mc_c.add(MyClass(5))
	Assert(mc_c.toString() = "[0, 1, 2, 3, 3, 4, 5]")
End Sub
Sub add_element_by_index()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	mc_c.add(0, MyClass(3))
	mc_c.add(MyClass(3))
	mc_c.add(MyClass(4))
	mc_c.add(MyClass(5))
	mc_c.add(4, MyClass(6))
	Assert(mc_c.toString() = "[3, 0, 1, 2, 6, 3, 4, 5]")
End Sub
Sub addAll_collection()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	
	Dim As mdList(MyClass) mc_c2
	mc_c2.addAll(mc_c)
	Assert(mc_c.size() = mc_c2.size())
	Assert(mc_c.toString() = mc_c2.toString())
End Sub
Sub addAll_collection_by_index()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	
	Dim As mdList(MyClass) mc_c2
	mc_c2.addAll(mc_c)
	
	mc_c.addAll(2, mc_c2)
	Assert(mc_c.toString() = "[0, 1, 0, 1, 1, 2, 1, 2]")
End Sub
Sub clear_()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	Assert(mc_c.size() = 4)
	mc_c.clear()
	Assert(mc_c.size() = 0)
End Sub
Sub clone()
	Print "clone not implemented!!!"
End Sub
Sub contains_object()
	Print "contains_object not implemented!!!"
End Sub
Sub contains_element()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	Assert(mc_c.contains(MyClass(2)))
End Sub
Sub containsAll()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	Dim As mdList(MyClass) mc_c2
	mc_c2.add(MyClass(0))
	mc_c2.add(MyClass(1))
	Assert(mc_c2.containsAll(mc_c) = FALSE)
	mc_c2.add(MyClass(2))
	Assert(mc_c2.containsAll(mc_c))
End Sub
Sub equals_object()
	Print "equals_object not implemented!!!"
End Sub
Sub equals_collection()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	Dim As mdList(MyClass) mc_c2
	mc_c2.add(MyClass(0))
	mc_c2.add(MyClass(1))
	Assert(mc_c.equals(mc_c2) = TRUE)
End Sub
Sub get_()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	mc_c.add(MyClass(3))
	mc_c.add(MyClass(4))
	mc_c.add(MyClass(5))
	
	For i As Long = 0 To mc_c.size() - 1
		Assert(MyClass(i) = mc_c.get(i))
	Next
End Sub
Sub getClass()
	Dim As mdList(MyClass) mc_c
	Assert(mc_c.getClass() = UCase("mdList(MyClass)"))
End Sub
Sub hashCode()
	Print "hashCode not implemented!!!"
End Sub
Sub isEmpty()
	Dim As mdList(MyClass) mc_c
	Assert(mc_c.isEmpty() = TRUE)
	mc_c.add(MyClass(0))
	Assert(mc_c.isEmpty() = FALSE)
End Sub
Sub indexOf_object()
	Print "indexOf_object not implemented!!!"
End Sub
Sub indexOf_element()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	For i As Long = 0 To mc_c.size() - 1
		Assert(mc_c.indexOf(MyClass(i)) = i)
	Next
End Sub
Sub iterator()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	Dim As mdIterator(MyClass) mc_c_iter = mc_c.iterator()
	Dim As Long i = 0
	Assert(mc_c_iter.hasNext() = TRUE)
	While mc_c_iter.hasNext()
		Dim As MyClass element = mc_c_iter.nex()
		Assert(element = Str(i))
		i += 1
	Wend
End Sub
Sub lastIndexOf_object()
	Print "lastIndexOf_object not implemented!!!"
End Sub
Sub lastIndexOf_element()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	For i As Long = 0 To mc_c.size() - 1
		Assert(mc_c.lastIndexOf(MyClass(i)) = i)
	Next
End Sub
Sub listIterator()
	Print "listIterator not implemented!!!"
End Sub
Sub listIterator_index()
	Print "listIterator_index not implemented!!!"
End Sub
Sub remove_index()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(2))
	mc_c.add(MyClass(1))
	Dim As String s_temp = mc_c.remove(1)
	Assert(mc_c.toString() = "[0, 1]")
	s_temp = mc_c.remove(0)
	Assert(mc_c.toString() = "[1]")
	s_temp = mc_c.remove(0)
	Assert(mc_c.toString() = "[]")
End Sub
Sub remove_object()
	Print "remove_object not implemented!!!"
End Sub
Sub remove_element()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(2))
	mc_c.add(MyClass(1))
	mc_c.remove(MyClass(2))
	Assert(mc_c.toString() = "[0, 1]")
	mc_c.remove(MyClass(0))
	Assert(mc_c.toString() = "[1]")
	mc_c.remove(MyClass(1))
	Assert(mc_c.toString() = "[]")
End Sub
Sub removeAll()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	mc_c.add(MyClass(3))
	mc_c.add(MyClass(4))
	mc_c.add(MyClass(5))
	Assert(mc_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdList(MyClass) mc_c2
	mc_c2.add(MyClass(1))
	mc_c2.add(MyClass(2))
	mc_c.removeAll(mc_c2)
	Assert(mc_c.toString() = "[0, 3, 4, 5]")
End Sub
Sub retainAll()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	mc_c.add(MyClass(3))
	mc_c.add(MyClass(4))
	mc_c.add(MyClass(5))
	Assert(mc_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdList(MyClass) mc_c2
	mc_c2.add(MyClass(1))
	mc_c2.add(MyClass(2))
	mc_c.retainAll(mc_c2)
	Assert(mc_c.toString() = "[1, 2]")
End Sub
Sub set()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	mc_c.add(MyClass(3))
	mc_c.add(MyClass(4))
	mc_c.add(MyClass(5))
	Assert(mc_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Assert(mc_c.set(3, MyClass(6)) = MyClass(3))
	Assert(mc_c.toString() = "[0, 1, 2, 6, 4, 5]")
End Sub
'Sub share()
'	Dim As mdList(MyClass) mc_c
'	mc_c.add(MyClass(0))
'	mc_c.add(MyClass(1))
'	mc_c.add(MyClass(2))
'	mc_c.add(MyClass(3))
'	Dim As mdList(MyClass) mc_c2
'	mc_c2.share(mc_c)
'	Assert(mc_c.toString() = mc_c2.toString())
'	Assert(mc_c.equals(mc_c2) = TRUE)
'End Sub
Sub size()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(2))
	mc_c.add(MyClass(1))
	Assert(mc_c.size() = 3)
	mc_c.remove(MyClass(2))
	Assert(mc_c.size() = 2)
End Sub
Sub subList()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	mc_c.add(MyClass(3))
	mc_c.add(MyClass(4))
	mc_c.add(MyClass(5))
	Assert(mc_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Assert(mc_c.subList(1, 4).toString() = "[1, 2, 3, 4]")
End Sub
Sub toArray()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	Dim As MyClass mc_c_array()
	mc_c.toArray(mc_c_array())
	Assert(mc_c.size() = 3)
	For i As Long = 0 To UBound(mc_c_array)
		Assert(mc_c_array(i) = Str(i))
	Next
End Sub
Sub toString()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	mc_c.add(MyClass(2))
	Assert(mc_c.toString() = "[0, 1, 2]")
End Sub

Sub Operator_Cast_Integer()
	Dim As mdList(MyClass) mc_c
	Dim As Integer mc_c_hashcode = mc_c
	Assert(mc_c_hashcode <> 0)
	Assert(mc_c_hashcode = mc_c.hashCode())
End Sub
Sub Operator_Cast_String()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	Dim As String mc_c_string = mc_c
	Assert(mc_c_string = mc_c.toString())
End Sub
Sub Operator_Let()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	Dim As mdList(MyClass) mc_c2
	mc_c2.add(MyClass(2))
	Assert(mc_c.toString() = "[0, 1]")
	Assert(mc_c2.toString() = "[2]")
	mc_c2 = mc_c
	Assert(mc_c2.toString() = "[0, 1]")
End Sub
Sub Operator_equals()
	Dim As mdList(MyClass) mc_c
	mc_c.add(MyClass(0))
	mc_c.add(MyClass(1))
	Dim As mdList(MyClass) mc_c2
	mc_c2.add(MyClass(0))
	Assert(mc_c.toString() <> mc_c2.toString())
	mc_c2.add(MyClass(1))
	Assert(mc_c.toString() = mc_c2.toString())
End Sub



constructor_empty()
constructor_element()
constructor_collection()
destructor_empty()

add_element()
add_element_by_index()
addAll_collection()
addAll_collection_by_index()
clear_()
'clone()
'contains_object()
contains_element()
containsAll()
'equals_object()
equals_collection()
get_()
getClass()
'hashCode()
'indexOf_object()
indexOf_element()
isEmpty()
iterator()
'lastIndexOf_object()
lastIndexOf_element()
'listIterator()
'listIterator_index()
remove_index()
'remove_object()
remove_element()
removeAll()
retainAll()
set()
'share()
size()
subList()
toArray()
toString()

Operator_Cast_Integer()
Operator_Cast_String()
Operator_Let()
Operator_equals()

