#Include Once "md/util/mdResourceBundle.bi"

Dim As mdResourceBundle bundles(0 To ...) = {mdResourceBundle.getBundle("Language", "de"), _
											 mdResourceBundle.getBundle("Language", "en"), _
											 mdResourceBundle.getBundle("Language", "fr")}

Dim As mdResourceBundle parent_de = mdResourceBundle.getBundle("Parent", "de")

Assert(bundles(0).getLocale() = "de")
Assert(bundles(1).getLocale() = "en")
Assert(bundles(2).getLocale() = "fr")

Assert(bundles(0).containsKey("parents") = FALSE)
bundles(0).setParent(parent_de)
Assert(bundles(0).getString("parents") = "Eltern")
Assert(bundles(0).containsKey("parents") = TRUE)
Assert(bundles(1).containsKey("parents") = FALSE)
Assert(bundles(2).containsKey("parents") = FALSE)


Assert(bundles(0).getString("test-one") = "Hallo Welt")
Assert(bundles(1).getString("test-one") = "Hello World")
Assert(bundles(2).getString("test-one") = "Bonjour le monde")
Assert(bundles(0).containsKey("test-one") = TRUE)
Assert(bundles(1).containsKey("test-one") = TRUE)
Assert(bundles(2).containsKey("test-one") = TRUE)

Assert(bundles(0).getString("test-two") = "")
Assert(bundles(1).getString("test-two") = "Hello {0}")
Assert(bundles(2).getString("test-two") = "Bonjour {0}")

Assert(bundles(0).getString("test-three") = "Hallo {0} und willkommen zu {1}")
Assert(bundles(1).getString("test-three") = "Hello {0} and welcome to {1}")
Assert(bundles(2).getString("test-three") = "Bonjour {0} et bienvenue a {1}")

Dim As String a1(0 To ...) = {"Joe", "foo", "present"}
Assert(bundles(0).getString("hallo-x-sign-into-x-and-get-your-x", a1()) = "Hallo Joe, melde dich bei foo an und erhalte dein present!")
Assert(bundles(1).getString("hallo-x-sign-into-x-and-get-your-x", a1()) = "Hello Joe, sign into foo and get your present!")
Assert(bundles(2).getString("hallo-x-sign-into-x-and-get-your-x", a1()) = "Bonjour Joe, enregistre-toi sur foo et obtiens ton present!")

Assert(bundles(0).getString("hallo-x-sign-into-x-and-get-your-x", "Joe foo present") = "Hallo Joe, melde dich bei foo an und erhalte dein present!")
Assert(bundles(1).getString("hallo-x-sign-into-x-and-get-your-x", "Joe foo present") = "Hello Joe, sign into foo and get your present!")
Assert(bundles(2).getString("hallo-x-sign-into-x-and-get-your-x", "Joe foo present") = "Bonjour Joe, enregistre-toi sur foo et obtiens ton present!")

Dim As String a2(0 To ...) = {"Joe"}
Assert(bundles(0).getString("test-four", a2()) = "Hallo Joe dein Name ist Joe oder {1}?")
Assert(bundles(1).getString("test-four", a2()) = "Hello Joe your name is Joe or {1}?")
Assert(bundles(2).getString("test-four", a2()) = "Bonjour Joe ton nom est Joe ou {1}?")

Assert(bundles(0).getString("present") = "Geschenk")
Assert(bundles(1).getString("present") = "present")
Assert(bundles(2).getString("present") = "cadeau")

Assert(bundles(0).getString("hello") = "Hallo")
Assert(bundles(1).getString("hello") = "Hello")
Assert(bundles(2).getString("hello") = "Bonjour")

Assert(bundles(0).getString("label") = "Ueberschrift")
Assert(bundles(1).getString("label") = "Header")
Assert(bundles(2).getString("label") = "Titre")

Assert(bundles(0).getString("your-name") = "Dein Name:")
Assert(bundles(1).getString("your-name") = "Your name:")
Assert(bundles(2).getString("your-name") = "Ton nom:")

Assert(bundles(0).getString("change-language") = "Sprache wechseln")
Assert(bundles(1).getString("change-language") = "Change language")
Assert(bundles(2).getString("change-language") = "Choisir le langage")
