#Include Once "md/util/mdSet.bi"

mdSetDeclare(Long)


Sub constructor_empty()
	Dim As mdSet(Long) l_c
	Assert(l_c.toString() = "[]")
End Sub
Sub constructor_element()
	Dim As mdSet(Long) l_c = 45462452
	Dim As Long l_c_array()
	l_c.toArray(l_c_array())
	Assert(l_c.toString() = "[45462452]")
	Assert(l_c_array(0) = 45462452)
	Assert(l_c_array(0) = 45462452)
End Sub
Sub constructor_collection()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(2)
	l_c.add(4)
	
	Dim As mdSet(Long) l_c2 = l_c
	Assert(l_c.size() = l_c2.size())
	Assert(l_c.toString() = l_c2.toString())
End Sub
Sub destructor_empty()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	Assert(l_c.size() = 1)
	l_c.Destructor()
	Assert(l_c.size() = 0)
End Sub

Sub add()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
End Sub
Sub addAll()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	
	Dim As mdSet(Long) l_c2
	l_c2.addAll(l_c)
	Assert(l_c.size() = l_c2.size())
	Assert(l_c.toString() = l_c2.toString())
End Sub
Sub clear_()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	Assert(l_c.size() = 3)
	l_c.clear()
	Assert(l_c.size() = 0)
End Sub
Sub contains_object()
	Print "contains_object not implemented!!!"
End Sub
Sub contains_element()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	Assert(l_c.contains(2))
End Sub
Sub containsAll()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	Dim As mdSet(Long) l_c2
	l_c2.add(0)
	l_c2.add(1)
	Assert(l_c2.containsAll(l_c) = FALSE)
	l_c2.add(2)
	Assert(l_c2.containsAll(l_c))
End Sub
Sub equals_object()
	Print "equals_object not implemented!!!"
End Sub
Sub equals_collection()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Dim As mdSet(Long) l_c2
	l_c2.add(0)
	l_c2.add(1)
	Assert(l_c.equals(l_c2) = TRUE)
End Sub
Sub hashCode()
	Print "hashCode not implemented!!!"
End Sub
Sub isEmpty()
	Dim As mdSet(Long) l_c
	Assert(l_c.isEmpty() = TRUE)
	l_c.add(0)
	Assert(l_c.isEmpty() = FALSE)
End Sub
Sub iterator()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Dim As mdIterator(Long) l_c_iter = l_c.iterator()
	Dim As Long j = 0
	Assert(l_c_iter.hasNext() = TRUE)
	While l_c_iter.hasNext()
		Dim As Long element = l_c_iter.nex()
		Assert(element = j)
		j += 1
	Wend
End Sub
Sub remove_index()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	l_c.remove(1)
	Assert(l_c.toString() = "[0, 1]")
	l_c.remove(0)
	Assert(l_c.toString() = "[1]")
	l_c.remove(0)
	Assert(l_c.toString() = "[]")
End Sub
Sub remove_object()
	Print "remove_object not implemented!!!"
End Sub
Sub remove_element()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	l_c.remove(CLng(2))
	Assert(l_c.toString() = "[0, 1]")
	l_c.remove(CLng(0))
	Assert(l_c.toString() = "[1]")
	l_c.remove(CLng(1))
	Assert(l_c.toString() = "[]")
End Sub
Sub removeAll()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdSet(Long) l_c2
	l_c2.add(1)
	l_c2.add(2)
	l_c.removeAll(l_c2)
	Assert(l_c.toString() = "[0, 3, 4, 5]")
End Sub
Sub retainAll()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdSet(Long) l_c2
	l_c2.add(1)
	l_c2.add(2)
	l_c.retainAll(l_c2)
	Assert(l_c.toString() = "[1, 2]")
End Sub
Sub size()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	Assert(l_c.size() = 3)
	l_c.remove(CLng(2))
	Assert(l_c.size() = 2)
End Sub
Sub toArray()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Dim As Long l_c_array()
	l_c.toArray(l_c_array())
	Assert(l_c.size() = 3)
	For j As Long = 0 To UBound(l_c_array)
		Assert(l_c_array(j) = j)
	Next
End Sub
Sub toString()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Assert(l_c.toString() = "[0, 1, 2]")
End Sub

Sub Operator_Cast_Integer()
	Dim As mdSet(Long) l_c
	Dim As Integer l_c_hashcode = l_c
	Assert(l_c_hashcode <> 0)
	Assert(l_c_hashcode = l_c.hashCode())
End Sub
Sub Operator_Cast_String()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Dim As String l_c_string = l_c
	Assert(l_c_string = l_c.toString())
End Sub
Sub Operator_Let()
	Dim As mdSet(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Dim As mdSet(Long) l_c2
	l_c2.add(2)
	Assert(l_c.toString() = "[0, 1]")
	Assert(l_c2.toString() = "[2]")
	l_c2 = l_c
	Assert(l_c2.toString() = "[0, 1]")
End Sub




constructor_empty()
constructor_element()
constructor_collection()
destructor_empty()

add()
addAll()
clear_()
'contains_object()
contains_element()
containsAll()
'equals_object()
equals_collection()
'hashCode()
isEmpty()
iterator()
remove_index()
'remove_object()
remove_element()
removeAll()
retainAll()
size()
toArray()
toString()

Operator_Cast_Integer()
Operator_Cast_String()
Operator_Let()

