#Include Once "md/util/mdStack.bi"

mdStackDeclare(Long)


Sub constructor_empty()
	Dim As mdStack(Long) l_c
	Assert(l_c.toString() = "[]")
End Sub
Sub constructor_element()
	Dim As mdStack(Long) l_c = 45462452
	Dim As Long l_c_array()
	l_c.toArray(l_c_array())
	Assert(l_c.toString() = "[45462452]")
	Assert(l_c_array(0) = 45462452)
	Assert(l_c_array(0) = 45462452)
End Sub
Sub constructor_collection()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(2)
	l_c.add(4)
	
	Dim As mdStack(Long) l_c2 = l_c
	Assert(l_c.size() = l_c2.size())
	Assert(l_c.toString() = l_c2.toString())
End Sub
Sub destructor_empty()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	Assert(l_c.size() = 1)
	l_c.Destructor()
	Assert(l_c.size() = 0)
End Sub

Sub add_element()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 3, 4, 5]")
	l_c.add(6)
	l_c.add(7)
	l_c.add(8)
	l_c.add(9)
	l_c.add(10)
	Assert(l_c.toString() = "[0, 1, 2, 3, 3, 4, 5, 6, 7, 8]")
End Sub
Sub add_element_by_index()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(0, 3)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	l_c.add(4, 6)
	Assert(l_c.toString() = "[3, 0, 1, 2, 6, 3, 4, 5]")
End Sub
Sub addAll_collection()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	
	Dim As mdStack(Long) l_c2
	l_c2.addAll(l_c)
	Assert(l_c.size() = l_c2.size())
	Assert(l_c.toString() = l_c2.toString())
End Sub
Sub addAll_collection_by_index()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	
	Dim As mdStack(Long) l_c2
	l_c2.addAll(l_c)
	
	l_c.addAll(2, l_c2)
	Assert(l_c.toString() = "[0, 1, 0, 1, 1, 2, 1, 2]")
End Sub
Sub addElement()
	Dim As mdStack(Long) l_c
	l_c.addElement(0)
	l_c.addElement(1)
	l_c.addElement(2)
	l_c.addElement(3)
	l_c.addElement(3)
	l_c.addElement(4)
	l_c.addElement(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 3, 4, 5]")
End Sub
Sub capacity()
	Dim As mdStack(Long) l_c
	Assert(l_c.capacity() = 10)
	l_c.ensureCapacity(100)
	Assert(l_c.capacity() = 100)
End Sub
Sub clear_()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	Assert(l_c.size() = 4)
	l_c.clear()
	Assert(l_c.size() = 0)
End Sub
Sub clone()
	Print "clone not implemented!!!"
End Sub
Sub contains_object()
	Print "contains_object not implemented!!!"
End Sub
Sub contains_element()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	Assert(l_c.contains(2))
End Sub
Sub containsAll()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(1)
	l_c.add(2)
	Dim As mdStack(Long) l_c2
	l_c2.add(0)
	l_c2.add(1)
	Assert(l_c2.containsAll(l_c) = FALSE)
	l_c2.add(2)
	Assert(l_c2.containsAll(l_c))
End Sub
Sub copyInto()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Dim As Long l_c_array()
	l_c.copyInto(l_c_array())
	Assert(l_c.size() = 3)
	For j As Long = 0 To UBound(l_c_array)
		Assert(l_c_array(j) = j)
	Next
End Sub
Sub elementAt()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	
	For i As Long = 0 To l_c.size() - 1
		Assert(i = l_c.elementAt(i))
	Next
End Sub
Sub elements()
	Print "elements not implemented!!!"
End Sub
Sub empty()
	Dim As mdStack(Long) l_c
	Assert(l_c.empty() = TRUE)
	l_c.add(0)
	Assert(l_c.empty() = FALSE)
End Sub
Sub ensureCapacity()
	Dim As mdStack(Long) l_c
	Assert(l_c.capacity() = 10)
	l_c.ensureCapacity(50)
	Assert(l_c.capacity() = 50)
End Sub
Sub equals_object()
	Print "equals_object not implemented!!!"
End Sub
Sub equals_collection()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Dim As mdStack(Long) l_c2
	l_c2.add(0)
	l_c2.add(1)
	Assert(l_c.equals(l_c2) = TRUE)
End Sub
Sub firstElement()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Assert(l_c.firstElement() = 0)
End Sub
Sub get_()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	
	For i As Long = 0 To l_c.size() - 1
		Assert(i = l_c.get(i))
	Next
End Sub
Sub getClass()
	Dim As mdStack(Long) l_c
	Assert(l_c.getClass() = UCase("mdStack(Long)"))
End Sub
Sub hashCode()
	Print "hashCode not implemented!!!"
End Sub
Sub isEmpty()
	Dim As mdStack(Long) l_c
	Assert(l_c.isEmpty() = TRUE)
	l_c.add(0)
	Assert(l_c.isEmpty() = FALSE)
End Sub
Sub insertElementAt()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.insertElementAt(3, 0)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	l_c.insertElementAt(6, 4)
	Assert(l_c.toString() = "[3, 0, 1, 2, 6, 3, 4, 5]")
End Sub
Sub indexOf_object()
	Print "indexOf_object not implemented!!!"
End Sub
Sub indexOf_element()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	For i As Long = 0 To l_c.size() - 1
		Assert(l_c.indexOf(i) = i)
	Next
End Sub
Sub indexOf_element_index()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(1)
	Assert(l_c.indexOf(1, 2) = 3)
End Sub
Sub iterator()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Dim As mdIterator(Long) l_c_iter = l_c.iterator()
	Dim As Long j = 0
	Assert(l_c_iter.hasNext() = TRUE)
	While l_c_iter.hasNext()
		Dim As Long element = l_c_iter.nex()
		Assert(element = j)
		j += 1
	Wend
End Sub
Sub lastElement()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Assert(l_c.lastElement() = 2)
End Sub
Sub lastIndexOf_object()
	Print "lastIndexOf_object not implemented!!!"
End Sub
Sub lastIndexOf_element()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	For i As Long = 0 To l_c.size() - 1
		Assert(l_c.lastIndexOf(i) = i)
	Next
End Sub
Sub lastIndexOf_element_index()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(1)
	Assert(l_c.lastIndexOf(1, 2) = 1)
End Sub
Sub listIterator()
	Print "listIterator not implemented!!!"
End Sub
Sub listIterator_index()
	Print "listIterator_index not implemented!!!"
End Sub
Sub peek_()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	Assert(l_c.toString() = "[0, 2, 1]")
	Assert(l_c.peek_() = 0)
	Assert(l_c.toString() = "[0, 2, 1]")
End Sub
Sub pop()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	Assert(l_c.toString() = "[0, 2, 1]")
	Assert(l_c.pop() = 0)
	Assert(l_c.toString() = "[2, 1]")
End Sub
Sub push()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	Assert(l_c.toString() = "[0, 2, 1]")
	l_c.push(5)
	Assert(l_c.toString() = "[5, 0, 2, 1]")
End Sub
Sub search_object()
	Print "search_object not implemented!!!"
End Sub
Sub search_element()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	For i As Long = 0 To l_c.size() - 1
		Assert(l_c.search(i) = i + 1)
	Next
End Sub
Sub remove_index()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	l_c.remove(1)
	Assert(l_c.toString() = "[0, 1]")
	l_c.remove(0)
	Assert(l_c.toString() = "[1]")
	l_c.remove(0)
	Assert(l_c.toString() = "[]")
End Sub
Sub remove_object()
	Print "remove_object not implemented!!!"
End Sub
Sub remove_element()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	l_c.remove(CLng(2))
	Assert(l_c.toString() = "[0, 1]")
	l_c.remove(CLng(0))
	Assert(l_c.toString() = "[1]")
	l_c.remove(CLng(1))
	Assert(l_c.toString() = "[]")
End Sub
Sub removeAll()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdStack(Long) l_c2
	l_c2.add(1)
	l_c2.add(2)
	l_c.removeAll(l_c2)
	Assert(l_c.toString() = "[0, 3, 4, 5]")
End Sub
Sub removeAllElements()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.size() = 6)
	l_c.removeAllElements()
	Assert(l_c.size() = 0)
End Sub
Sub removeElement()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(2)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 2, 5]")
	l_c.removeElement(2)
	Assert(l_c.toString() = "[0, 1, 3, 4, 2, 5]")
End Sub
Sub removeElementAt()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	l_c.removeElementAt(1)
	Assert(l_c.toString() = "[0, 1]")
	l_c.removeElementAt(0)
	Assert(l_c.toString() = "[1]")
	l_c.removeElementAt(0)
	Assert(l_c.toString() = "[]")
End Sub
Sub removeRange()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	l_c.removeRange(2, 5)
	Assert(l_c.toString() = "[0, 1, 5]")
End Sub
Sub retainAll()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdStack(Long) l_c2
	l_c2.add(1)
	l_c2.add(2)
	l_c.retainAll(l_c2)
	Assert(l_c.toString() = "[1, 2]")
End Sub
Sub set()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Assert(l_c.set(3, 6) = 3)
	Assert(l_c.toString() = "[0, 1, 2, 6, 4, 5]")
End Sub
Sub setElementAt()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	l_c.setElementAt(6, 3)
	Assert(l_c.toString() = "[0, 1, 2, 6, 4, 5]")
End Sub
Sub setSize()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	l_c.setSize(8)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5, 0, 0]")
	l_c.setSize(4)
	Assert(l_c.toString() = "[0, 1, 2, 3]")
End Sub
Sub size()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(2)
	l_c.add(1)
	Assert(l_c.size() = 3)
	l_c.remove(CLng(2))
	Assert(l_c.size() = 2)
End Sub
Sub subList()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	l_c.add(3)
	l_c.add(4)
	l_c.add(5)
	Assert(l_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Assert(l_c.subList(1, 4).toString() = "[1, 2, 3, 4]")
End Sub
Sub toArray()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Dim As Long l_c_array()
	l_c.toArray(l_c_array())
	Assert(l_c.size() = 3)
	For j As Long = 0 To UBound(l_c_array)
		Assert(l_c_array(j) = j)
	Next
End Sub
Sub toString()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Assert(l_c.toString() = "[0, 1, 2]")
End Sub
Sub trimToSize()
	Dim As mdStack(Long) l_c
	l_c.ensureCapacity(50)
	Assert(l_c.capacity() = 50)
	Assert(l_c.size() = 0)
	l_c.add(0)
	l_c.add(1)
	l_c.add(2)
	Assert(l_c.size() = 3)
	l_c.trimToSize()
	Assert(l_c.capacity() = 3)
End Sub

Sub Operator_Cast_Integer()
	Dim As mdStack(Long) l_c
	Dim As Integer l_c_hashcode = l_c
	Assert(l_c_hashcode <> 0)
	Assert(l_c_hashcode = l_c.hashCode())
End Sub
Sub Operator_Cast_String()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Dim As String l_c_string = l_c
	Assert(l_c_string = l_c.toString())
End Sub
Sub Operator_Let()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Dim As mdStack(Long) l_c2
	l_c2.add(2)
	Assert(l_c.toString() = "[0, 1]")
	Assert(l_c2.toString() = "[2]")
	l_c2 = l_c
	Assert(l_c2.toString() = "[0, 1]")
End Sub
Sub Operator_equals()
	Dim As mdStack(Long) l_c
	l_c.add(0)
	l_c.add(1)
	Dim As mdStack(Long) l_c2
	l_c2.add(0)
	Assert(l_c.toString() <> l_c2.toString())
	l_c2.add(1)
	Assert(l_c.toString() = l_c2.toString())
End Sub



constructor_empty()
constructor_element()
constructor_collection()
destructor_empty()

constructor_empty()
constructor_element()
constructor_collection()
destructor_empty()

add_element()
add_element_by_index()
addAll_collection()
addAll_collection_by_index()
addElement()
capacity()
clear_()
'clone()
'contains_object()
contains_element()
containsAll()
copyInto()
elementAt()
'elements()
empty()
ensureCapacity()
'equals_object()
equals_collection()
firstElement()
get_()
getClass()
'hashCode()
'indexOf_object()
indexOf_element()
indexOf_element_index()
isEmpty()
insertElementAt()
iterator()
lastElement()
'lastIndexOf_object()
lastIndexOf_element()
lastIndexOf_element_index()
'listIterator()
'listIterator_index()
peek_()
pop()
push()
'search_object()
search_element()
remove_index()
'remove_object()
remove_element()
removeAll()
removeAllElements()
removeElement()
removeElementAt()
removeRange()
retainAll()
set()
setElementAt()
setSize()
size()
subList()
toArray()
toString()
trimToSize()

Operator_Cast_Integer()
Operator_Cast_String()
Operator_Let()
Operator_equals()

