#Include Once "md/util/mdVector.bi"

mdVectorDeclare(String)


Sub constructor_empty()
	Dim As mdVector(String) s_c
	Assert(s_c.toString() = "[]")
End Sub
Sub constructor_element()
	Dim As mdVector(String) s_c = "Test"
	Dim As String s_c_array()
	s_c.toArray(s_c_array())
	Assert(s_c.toString() = "[Test]")
	Assert(s_c_array(0) = "Test")
End Sub
Sub constructor_collection()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("2")
	s_c.add("4")
	
	Dim As mdVector(String) s_c2 = s_c
	Assert(s_c.size() = s_c2.size())
	Assert(s_c.toString() = s_c2.toString())
End Sub
Sub destructor_empty()
	Dim As mdVector(String) s_c
	s_c.add("0")
	Assert(s_c.size() = 1)
	s_c.Destructor()
	Assert(s_c.size() = 0)
End Sub

Sub add_element()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 3, 4, 5]")
	s_c.add("6")
	s_c.add("7")
	s_c.add("8")
	s_c.add("9")
	s_c.add("10")
	Assert(s_c.toString() = "[0, 1, 2, 3, 3, 4, 5, 6, 7, 8]")
End Sub
Sub add_element_by_index()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add(0, "3")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	s_c.add(4, "6")
	Assert(s_c.toString() = "[3, 0, 1, 2, 6, 3, 4, 5]")
End Sub
Sub addAll_collection()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("1")
	s_c.add("2")
	
	Dim As mdVector(String) s_c2
	s_c2.addAll(s_c)
	Assert(s_c.size() = s_c2.size())
	Assert(s_c.toString() = s_c2.toString())
End Sub
Sub addAll_collection_by_index()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("1")
	s_c.add("2")
	
	Dim As mdVector(String) s_c2
	s_c2.addAll(s_c)
	
	s_c.addAll(2, s_c2)
	Assert(s_c.toString() = "[0, 1, 0, 1, 1, 2, 1, 2]")
End Sub
Sub addElement()
	Dim As mdVector(String) s_c
	s_c.addElement("0")
	s_c.addElement("1")
	s_c.addElement("2")
	s_c.addElement("3")
	s_c.addElement("3")
	s_c.addElement("4")
	s_c.addElement("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 3, 4, 5]")
End Sub
Sub capacity()
	Dim As mdVector(String) s_c
	Assert(s_c.capacity() = 10)
	s_c.ensureCapacity(100)
	Assert(s_c.capacity() = 100)
End Sub
Sub clear_()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("1")
	s_c.add("2")
	Assert(s_c.size() = 4)
	s_c.clear()
	Assert(s_c.size() = 0)
End Sub
Sub clone()
	Print "clone not implemented!!!"
End Sub
Sub contains_object()
	Print "contains_object not implemented!!!"
End Sub
Sub contains_element()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("1")
	s_c.add("2")
	Assert(s_c.contains("2"))
End Sub
Sub containsAll()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("1")
	s_c.add("2")
	Dim As mdVector(String) s_c2
	s_c2.add("0")
	s_c2.add("1")
	Assert(s_c2.containsAll(s_c) = FALSE)
	s_c2.add("2")
	Assert(s_c2.containsAll(s_c))
End Sub
Sub copyInto()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	Dim As String s_c_array()
	s_c.copyInto(s_c_array())
	Assert(s_c.size() = 3)
	For i As Long = 0 To UBound(s_c_array)
		Assert(s_c_array(i) = Str(i))
	Next
End Sub
Sub elementAt()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	
	For i As Long = 0 To s_c.size() - 1
		Assert(Str(i) = s_c.elementAt(i))
	Next
End Sub
Sub elements()
	Print "elements not implemented!!!"
End Sub
Sub ensureCapacity()
	Dim As mdVector(String) s_c
	Assert(s_c.capacity() = 10)
	s_c.ensureCapacity(50)
	Assert(s_c.capacity() = 50)
End Sub
Sub equals_object()
	Print "equals_object not implemented!!!"
End Sub
Sub equals_collection()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	Dim As mdVector(String) s_c2
	s_c2.add("0")
	s_c2.add("1")
	Assert(s_c.equals(s_c2) = TRUE)
End Sub
Sub firstElement()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	Assert(s_c.firstElement() = "0")
End Sub
Sub get_()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	
	For i As Long = 0 To s_c.size() - 1
		Assert(Str(i) = s_c.get(i))
	Next
End Sub
Sub getClass()
	Dim As mdVector(String) s_c
	Assert(s_c.getClass() = UCase("mdVector(String)"))
End Sub
Sub hashCode()
	Print "hashCode not implemented!!!"
End Sub
Sub isEmpty()
	Dim As mdVector(String) s_c
	Assert(s_c.isEmpty() = TRUE)
	s_c.add("0")
	Assert(s_c.isEmpty() = FALSE)
End Sub
Sub insertElementAt()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.insertElementAt("3", 0)
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	s_c.insertElementAt("6", 4)
	Assert(s_c.toString() = "[3, 0, 1, 2, 6, 3, 4, 5]")
End Sub
Sub indexOf_object()
	Print "indexOf_object not implemented!!!"
End Sub
Sub indexOf_element()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	For i As Long = 0 To s_c.size() - 1
		Assert(s_c.indexOf(Str(i)) = i)
	Next
End Sub
Sub indexOf_element_index()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("1")
	Assert(s_c.indexOf("1", 2) = 3)
End Sub
Sub iterator()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	Dim As mdIterator(String) s_c_iter = s_c.iterator()
	Dim As Long i = 0
	Assert(s_c_iter.hasNext() = TRUE)
	While s_c_iter.hasNext()
		Dim As String element = s_c_iter.nex()
		Assert(element = Str(i))
		i += 1
	Wend
End Sub
Sub lastElement()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	Assert(s_c.lastElement() = "2")
End Sub
Sub lastIndexOf_object()
	Print "lastIndexOf_object not implemented!!!"
End Sub
Sub lastIndexOf_element()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	For i As Long = 0 To s_c.size() - 1
		Assert(s_c.lastIndexOf(Str(i)) = i)
	Next
End Sub
Sub lastIndexOf_element_index()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("1")
	Assert(s_c.lastIndexOf("1", 2) = 1)
	Assert(s_c.lastIndexOf("1", 3) = 3)
End Sub
Sub listIterator()
	Print "listIterator not implemented!!!"
End Sub
Sub listIterator_index()
	Print "listIterator_index not implemented!!!"
End Sub
Sub remove_index()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("2")
	s_c.add("1")
	Dim As String s_temp = s_c.remove(1)
	Assert(s_c.toString() = "[0, 1]")
	s_temp = s_c.remove(0)
	Assert(s_c.toString() = "[1]")
	s_temp = s_c.remove(0)
	Assert(s_c.toString() = "[]")
End Sub
Sub remove_object()
	Print "remove_object not implemented!!!"
End Sub
Sub remove_element()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("2")
	s_c.add("1")
	s_c.remove("2")
	Assert(s_c.toString() = "[0, 1]")
	s_c.remove("0")
	Assert(s_c.toString() = "[1]")
	s_c.remove("1")
	Assert(s_c.toString() = "[]")
End Sub
Sub removeAll()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdVector(String) s_c2
	s_c2.add("1")
	s_c2.add("2")
	s_c.removeAll(s_c2)
	Assert(s_c.toString() = "[0, 3, 4, 5]")
End Sub
Sub removeAllElements()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.size() = 6)
	s_c.removeAllElements()
	Assert(s_c.size() = 0)
End Sub
Sub removeElement()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("2")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 4, 2, 5]")
	s_c.removeElement("2")
	Assert(s_c.toString() = "[0, 1, 3, 4, 2, 5]")
End Sub
Sub removeElementAt()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("2")
	s_c.add("1")
	s_c.removeElementAt(1)
	Assert(s_c.toString() = "[0, 1]")
	s_c.removeElementAt(0)
	Assert(s_c.toString() = "[1]")
	s_c.removeElementAt(0)
	Assert(s_c.toString() = "[]")
End Sub
Sub removeRange()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 4, 5]")
	s_c.removeRange(2, 5)
	Assert(s_c.toString() = "[0, 1, 5]")
End Sub
Sub retainAll()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Dim As mdVector(String) s_c2
	s_c2.add("1")
	s_c2.add("2")
	s_c.retainAll(s_c2)
	Assert(s_c.toString() = "[1, 2]")
End Sub
Sub set()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Assert(s_c.set(3, "6") = "3")
	Assert(s_c.toString() = "[0, 1, 2, 6, 4, 5]")
End Sub
Sub setElementAt()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 4, 5]")
	s_c.setElementAt("6", 3)
	Assert(s_c.toString() = "[0, 1, 2, 6, 4, 5]")
End Sub
Sub setSize()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 4, 5]")
	s_c.setSize(8)
	Assert(s_c.toString() = "[0, 1, 2, 3, 4, 5, , ]")
	s_c.setSize(4)
	Assert(s_c.toString() = "[0, 1, 2, 3]")
End Sub
Sub size()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("2")
	s_c.add("1")
	Assert(s_c.size() = 3)
	s_c.remove("2")
	Assert(s_c.size() = 2)
End Sub
Sub subList()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	s_c.add("3")
	s_c.add("4")
	s_c.add("5")
	Assert(s_c.toString() = "[0, 1, 2, 3, 4, 5]")
	Assert(s_c.subList(1, 4).toString() = "[1, 2, 3, 4]")
End Sub
Sub toArray()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	Dim As String s_c_array()
	s_c.toArray(s_c_array())
	Assert(s_c.size() = 3)
	For i As Long = 0 To UBound(s_c_array)
		Assert(s_c_array(i) = Str(i))
	Next
End Sub
Sub toString()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	Assert(s_c.toString() = "[0, 1, 2]")
End Sub
Sub trimToSize()
	Dim As mdVector(String) s_c
	s_c.ensureCapacity(50)
	Assert(s_c.capacity() = 50)
	Assert(s_c.size() = 0)
	s_c.add("0")
	s_c.add("1")
	s_c.add("2")
	Assert(s_c.size() = 3)
	s_c.trimToSize()
	Assert(s_c.capacity() = 3)
End Sub

Sub Operator_Cast_Integer()
	Dim As mdVector(String) s_c
	Dim As Integer s_c_hashcode = s_c
	Assert(s_c_hashcode <> 0)
	Assert(s_c_hashcode = s_c.hashCode())
End Sub
Sub Operator_Cast_String()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	Dim As String s_c_string = s_c
	Assert(s_c_string = s_c.toString())
End Sub
Sub Operator_Let()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	Dim As mdVector(String) s_c2
	s_c2.add("2")
	Assert(s_c.toString() = "[0, 1]")
	Assert(s_c2.toString() = "[2]")
	s_c2 = s_c
	Assert(s_c2.toString() = "[0, 1]")
End Sub
Sub Operator_equals()
	Dim As mdVector(String) s_c
	s_c.add("0")
	s_c.add("1")
	Dim As mdVector(String) s_c2
	s_c2.add("0")
	Assert(s_c.toString() <> s_c2.toString())
	s_c2.add("1")
	Assert(s_c.toString() = s_c2.toString())
End Sub



constructor_empty()
constructor_element()
constructor_collection()
destructor_empty()

constructor_empty()
constructor_element()
constructor_collection()
destructor_empty()

add_element()
add_element_by_index()
addAll_collection()
addAll_collection_by_index()
addElement()
capacity()
clear_()
'clone()
'contains_object()
contains_element()
containsAll()
copyInto()
elementAt()
'elements()
ensureCapacity()
'equals_object()
equals_collection()
firstElement()
get_()
getClass()
'hashCode()
'indexOf_object()
indexOf_element()
indexOf_element_index()
isEmpty()
insertElementAt()
iterator()
lastElement()
'lastIndexOf_object()
lastIndexOf_element()
lastIndexOf_element_index()
'listIterator()
'listIterator_index()
remove_index()
'remove_object()
remove_element()
removeAll()
removeAllElements()
removeElement()
removeElementAt()
removeRange()
retainAll()
set()
setElementAt()
setSize()
size()
subList()
toArray()
toString()
trimToSize()

Operator_Cast_Integer()
Operator_Cast_String()
Operator_Let()
Operator_equals()

